package desktophe;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.LineStyleEvent;
import org.eclipse.swt.custom.LineStyleListener;
import org.eclipse.swt.custom.StyleRange;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.RGB;

/**
 * L[[hnCCg\邽߂̃XiNX
 * 
 * @author kohno
 */
public class HighlightListener implements LineStyleListener {
	/** nCCg\ɎgpF */
	private static final RGB[] HIGHLIGHT_COLORS = {
		new RGB(255, 255, 36),
		new RGB(122, 253, 115),
		new RGB(251, 162, 249),
		new RGB(117, 251, 241),
		new RGB(255, 179, 102),
	};
	
	/** nCCgL[[h̃Xg */
	private List keywordList_; 
	

	/**
	 * RXgN^
	 * 
	 * @param list nCCgL[[h̃Xg
	 */
	public HighlightListener(List list) {
		keywordList_ = list;
	}
	
	/**
	 * This method is called when a line is about to be drawn in order to get the line's style information.
	 * 
	 * @param event the given event
	 */
	public void lineGetStyle(LineStyleEvent event) {
		String text = event.lineText;
		ArrayList styles = new ArrayList();

		for (int i=0; i<keywordList_.size(); i++) {	
			int lastIndex = 0;
			int index = 0;
			int colorIndex = i % HIGHLIGHT_COLORS.length;
			String keyword = keywordList_.get(i).toString();
			
			while ((index = text.toLowerCase().indexOf(keyword.toLowerCase(), lastIndex)) != -1) {
				StyleRange range = new StyleRange();
				range.start = event.lineOffset + index;
				range.length = keyword.length();
				range.background = new Color(event.display, HIGHLIGHT_COLORS[colorIndex]);
				range.fontStyle = SWT.BOLD;
				styles.add(range);
				lastIndex = index + keyword.length();
			}
		}
		
		event.styles = (StyleRange[]) styles.toArray(new StyleRange[styles.size()]);
	}
}
