package desktophe;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import desktophe.model.IndexSettingsModel;

/**
 * CfbNXݒ̎舵̃wp[NX
 * 
 * @author kohno
 */
public class IndexSettingManager {

	private IndexSettingsModel oldSetting_;
	private IndexSettingsModel newSetting_;
	
	
	/**
	 * RXgN^
	 * 
	 * @param oldSetting Âݒ
	 * @param newSetting Vݒ
	 */
	public IndexSettingManager(IndexSettingsModel oldSetting, IndexSettingsModel newSetting) {
		oldSetting_ = oldSetting;
		newSetting_ = newSetting;
	}
	
	/**
	 * CfbNXΏۂ̃tH_ƂĎwꂽ̂Ԃ\bh
	 * 
	 * @return
	 */
	public List getRemovedTargetFolderList() {
		List removedFolderList = new ArrayList();
		
		compare:
		for (int i=0; i<oldSetting_.getTargetFolderList().size(); i++) {
			String oldFolderStr = (String)oldSetting_.getTargetFolderList().get(i);
			File oldFolder = new File(oldFolderStr);
			
			for (int j=0; j<newSetting_.getTargetFolderList().size(); j++) {
				String newFolderStr = (String)newSetting_.getTargetFolderList().get(j);
				File newFolder = new File(newFolderStr);
				File parent = oldFolder;
				
				while (parent != null) {
					if (parent.equals( newFolder ))  continue compare;
					
					parent = parent.getParentFile();
				}
			}
			
			removedFolderList.add(oldFolderStr);
		}

		return removedFolderList;
	}
	
	/**
	 * eLXgt@CƂăCfbNXt@CŁAwꂽgqԂ\bh
	 * 
	 * @return
	 */
	public List getRemovedTextExtension() {
		List removedList = new ArrayList();
		
		if (oldSetting_.getAdditionalTextExtension().length() == 0)  return removedList;

		String[] oldext = oldSetting_.getAdditionalTextExtension().split(",");
		String[] newext = newSetting_.getAdditionalTextExtension().split(",");

		check:
		for (int i=0; i<oldext.length; i++) {
			if (oldext[i].length() == 0)  continue;
			
			for (int j=0; j<newext.length; j++) {
				if ( oldext[i].equals( newext[j] ) ) {
					continue check;
				}
				
				if (j == newext.length - 1) {
					removedList.add( oldext[i] );
				}
			}
		}
		
		return removedList;
	}

	/**
	 * HTMLt@CƂăCfbNXt@CŁAwꂽgqԂ\bh
	 * 
	 * @return
	 */
	public List getRemovedHtmlExtension() {
		List removedList = new ArrayList();
		
		if (oldSetting_.getAdditionalHtmlExtension().length() == 0)  return removedList;

		String[] oldext = oldSetting_.getAdditionalHtmlExtension().split(",");
		String[] newext = newSetting_.getAdditionalHtmlExtension().split(",");

		check:
		for (int i=0; i<oldext.length; i++) {
			if (oldext[i].length() == 0)  continue;
			
			for (int j=0; j<newext.length; j++) {
				if ( oldext[i].equals( newext[j] ) ) {
					continue check;
				}
				
				if (j == newext.length - 1) {
					removedList.add( oldext[i] );
				}
			}
		}
		
		return removedList;
	}

	/**
	 * Mimet@CƂăCfbNXt@CŁAwꂽgqԂ\bh
	 * 
	 * @return
	 */
	public List getRemovedMimeExtension() {
		List removedList = new ArrayList();
		
		if (oldSetting_.getAdditionalMimeExtension().length() == 0)  return removedList;

		String[] oldext = oldSetting_.getAdditionalMimeExtension().split(",");
		String[] newext = newSetting_.getAdditionalMimeExtension().split(",");

		check:
		for (int i=0; i<oldext.length; i++) {
			if (oldext[i].length() == 0)  continue;
			
			for (int j=0; j<newext.length; j++) {
				if ( oldext[i].equals( newext[j] ) ) {
					continue check;
				}
				
				if (j == newext.length - 1) {
					removedList.add( oldext[i] );
				}
			}
		}
		
		return removedList;
	}
}
