package desktophe;

import hidemarumail.HidemaruMailPlugin;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.io.Writer;
import java.net.MalformedURLException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Properties;

import org.eclipse.swt.SWT;
import org.eclipse.swt.browser.Browser;
import org.eclipse.swt.custom.LineStyleListener;
import org.eclipse.swt.custom.SashForm;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.events.ArmEvent;
import org.eclipse.swt.events.ArmListener;
import org.eclipse.swt.events.ControlEvent;
import org.eclipse.swt.events.ControlListener;
import org.eclipse.swt.events.FocusAdapter;
import org.eclipse.swt.events.FocusEvent;
import org.eclipse.swt.events.KeyAdapter;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.events.ShellAdapter;
import org.eclipse.swt.events.ShellEvent;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Cursor;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.FontData;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.program.Program;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Spinner;
import org.eclipse.swt.widgets.TabFolder;
import org.eclipse.swt.widgets.TabItem;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.ToolBar;
import org.eclipse.swt.widgets.ToolItem;
import org.eclipse.swt.widgets.Tree;
import org.eclipse.swt.widgets.TreeColumn;
import org.eclipse.swt.widgets.TreeItem;

import desktophe.dialog.AboutDialog;
import desktophe.dialog.AdvancedIndexSettingDialog;
import desktophe.dialog.GeneralSettingDialog;
import desktophe.dialog.IndexSettingDialog;
import desktophe.dialog.ProgressDialog;
import desktophe.model.AdvancedIndexSettingModel;
import desktophe.model.GeneralSettingsModel;
import desktophe.model.IndexSettingsModel;
import desktophe.plugin.FirefoxPlugin;
import desktophe.thread.RemoveAdditionalExtensionThread;
import desktophe.thread.RemoveTargetFolderThread;
import desktophe.thread.TextFileLoadThread;
import estraier.Condition;
import estraier.Database;
import estraier.Document;
import estraier.Result;

/**
 * CEBhE
 * 
 * @author kohno
 */
public class MainFrame {
	public static final int HORIZONTAL_SPACING = 3;
    public static final int MARGIN_WIDTH = 0;
    public static final int MARGIN_HEIGHT = 2;

    /** CEBhE */
	private Shell shell_;
	
	/** []eLXg{bNX */
	private Text textSearch_;

	/** t@Cꗗc[ */
	private Tree treeFileList_;
	
	/** ؂ */
	private SashForm horizontalSash_;
	
	/** ؂ */
	private SashForm verticalSash_;
	
	/** Xe[^Xo[ */
	private Label statusBar_;
	
	/** c[̃[gACe */
	private TreeItem treeRootItem_;
	
	/** c[Rg[ */
	private Tree treeSearchCondition_;
	
	/** "t"WI{^ */
	private Button checkOrderDate_;
	
	/** "XRA"WI{^ */
	private Button checkOrderScore_;

	/** nCCgX^C */
	private LineStyleListener lineStyleListener_;
	
	/** CfbNX֘A̐ݒ */
	private IndexSettingsModel indexSettings_ = new IndexSettingsModel();
	
	/** SʓIȐݒ */
	private GeneralSettingsModel generalSettings_ = new GeneralSettingsModel();
	
	/** ㋉ҌCfbNXݒ */
	private AdvancedIndexSettingModel advancedIndexSettingModel_ = new AdvancedIndexSettingModel();

	/** "Tv"eLXgRg[ */
	private StyledText textBodySummary_;

	/** "S"eLXgRg[ */
	private StyledText textBodyFullText_;

	private Display display_;

	/** [S]^ǔc[o[ */
	private ToolBar toolbarSearchWord_;

	/** [uEU]^ǔc[o[ */
	private ToolBar toolbarSearchWordBrowser_;

	/** ACR */
	private Image imageIconSmall_;

	/** ACR */
	private Image imageIconBig_;

	/** ACR */
	private Image imageIconBig48_;

	/** {̈ɕ\t@C̃pX */
	private String bodyTextFilePath_ = "";
	
	/** {̈ɕ\t@C̃^Cv */
	private String bodyTextFileType_ = "";

	/** "Tv"^uɕ\镶ݒXsRg[ */
	private Spinner spinnerSummaryCount_;

	private TreeItem[] lastFileTreeSelection_;

	/** t@C̎ނIhbv_EXg */
	private Combo cmbFileType_;
	
	/** hbv_EXgɑΉA@type */
	private ArrayList listFileType_;

	private TabFolder tabFolderBodyPane_;

	private Browser browser_;

	/** uEU^ǔc[o[ŁAOɌꂽ */
	private String lastSearchWord_;

	/** ʏ펞iő剻AŏĂȂƂj̃EBhEʒuATCY */
	private Rectangle rectNormal_ = null;
	
	/** CfbNX֘Ãj[ */
	private MenuItem menuitemFile_StartIndexing_;
	private MenuItem menuitemFile_PurgeIndex_;
	private MenuItem menuitemFile_ExtractKeywords_;
	private MenuItem menuitemFile_OptimizeIndex_;
	private TextFileLoadThread textFileLoadThread_;
	
	/** t@CꗗŌݑIĂhLg̃f[^ */
	private Document currentlySelectedDocument_ = null;

	/** Iꂽt@C̏\邽߂́Awb_̈ */
	private Composite cmpFileInfo;

	private SelectionAdapter treeSearchCondition_SelectionAdapter_ = null;
	
	/**
	 * RXgN^
	 */
	MainFrame() {
        GridData gridDataFillHorizontal = new GridData(GridData.FILL_HORIZONTAL);
		GridData gridDataFillBoth = new GridData(GridData.FILL_BOTH);

		display_ = new Display();
		shell_ = new Shell(display_);

	    // EBhẼ^Cgw
	    shell_.setText(Messages.getString("MainFrame.WindowTitle")); //$NON-NLS-1$
	    shell_.setLayout(new GridLayout(1, false));
	    shell_.addShellListener(new ShellAdapter() {
			public void shellClosed(ShellEvent arg0) {
				shell_shellClosed(arg0);
			}
	    });
	    shell_.addControlListener(new ControlListener() {
			public void controlMoved(ControlEvent arg0) {
				shell_controlMoved(arg0);
			}
			public void controlResized(ControlEvent arg0) {
				shell_controlResized(arg0);
			}
	    });
	    
	    // c[o[̗̈
	    Composite canvas = new Composite(shell_, SWT.NONE);
	    GridLayout layout = new GridLayout(6, false);
        layout.horizontalSpacing = HORIZONTAL_SPACING;
        layout.marginWidth = MARGIN_WIDTH;
        layout.marginHeight = MARGIN_HEIGHT;
        canvas.setLayout(layout);
        canvas.setLayoutData(gridDataFillHorizontal);
	    
        createToolbar(canvas);

	    // E
	    Label line = new Label(shell_, SWT.SEPARATOR | SWT.HORIZONTAL);
	    GridData ddata = new GridData(GridData.HORIZONTAL_ALIGN_FILL);
	    line.setLayoutData(ddata);   
	    
	    horizontalSash_ = new SashForm(shell_, SWT.HORIZONTAL);
	    horizontalSash_.setLayoutData(gridDataFillBoth);
	    
	    // c[
	    treeSearchCondition_ = new Tree(horizontalSash_, SWT.BORDER | SWT.SINGLE);
	    
	    treeSearchCondition_SelectionAdapter_ = new SelectionAdapter() {
			public void widgetSelected(SelectionEvent arg0) {
				treeSearchCondition_widgetSelected(arg0);
			}
	    };
	    
	    treeSearchCondition_.addSelectionListener( treeSearchCondition_SelectionAdapter_ );
	    treeSearchCondition_.addKeyListener(new KeyAdapter() {
			public void keyPressed(KeyEvent arg0) {
				treeSearchCondition_keyPressed(arg0);
			}
	    });
	    treeSearchCondition_.addMouseListener(new MouseAdapter() {
	    	public void mouseDown(MouseEvent e) {
				treeSearchCondition__mouseDown(e);
	    	};
			public void mouseUp(MouseEvent e) {
				treeSearchCondition__mouseUp(e);
			}
		});
	    
		treeRootItem_ = new TreeItem(treeSearchCondition_, SWT.NULL);
		treeRootItem_.setText(Messages.getString("MainFrame.SearchCondition")); //$NON-NLS-1$
	    
	    verticalSash_ = new SashForm(horizontalSash_, SWT.VERTICAL);

	    // t@Cꗗc[
	    treeFileList_ = new Tree(verticalSash_, SWT.FULL_SELECTION | SWT.BORDER | SWT.VIRTUAL);
		treeFileList_.setHeaderVisible(true);
		treeFileList_.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent arg0) {
				treeFileList_widgetSelected(arg0);
			}
		});
		treeFileList_.addMouseListener(new MouseAdapter() {
			public void mouseDoubleClick(MouseEvent arg0) {
				treeFileList_mouseDoubleClick(arg0);
			}
			
			public void mouseUp(MouseEvent e) {
				treeFileList_mouseUp(e);
			}
		});
		treeFileList_.addKeyListener(new KeyAdapter() {
			public void keyPressed(KeyEvent arg0) {
				treeFileList_keyPressed(arg0);
			}
		});
	    
	    // wb_ݒ
	    String[] cols = {Messages.getString("MainFrame.FileListColumnHeader.FileName"), Messages.getString("MainFrame.FileListColumnHeader.Score"), Messages.getString("MainFrame.FileListColumnHeader.Size"),Messages.getString("MainFrame.FileListColumnHeader.Type"), Messages.getString("MainFrame.FileListColumnHeader.ModifiedDate"), Messages.getString("MainFrame.FileListColumnHeader.Folder")}; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
	    for(int i=0; i<cols.length; i++){
	    	TreeColumn col = new TreeColumn(treeFileList_, SWT.LEFT);
	    	col.setText(cols[i]);
	    	col.setWidth(150);
	    	
	    	if (i == 1 || i == 2)  col.setAlignment(SWT.RIGHT);
	    }

	    // {vr[̈쐬
	    Composite compositeBodyPane = new Composite(verticalSash_, SWT.NULL);
	    
	    {
	    	GridLayout gridLayout = new GridLayout(1, false);
	    	compositeBodyPane.setLayout(gridLayout);
	    	
		    cmpFileInfo = new Composite(compositeBodyPane, SWT.NULL);
		    
		    // Ԃł́As̋̃xwb_̈ɐݒ肷
	    	new Label(cmpFileInfo, SWT.NULL);
		    
		    
			GridLayout gridLayout2 = new GridLayout(1, false);
	    	gridLayout2.marginHeight = 0;
	    	gridLayout2.marginTop = 0;
	    	gridLayout2.marginBottom = 0;
	    	cmpFileInfo.setLayout(gridLayout2);
	    	cmpFileInfo.setLayoutData(gridDataFillHorizontal);
	    }

	    tabFolderBodyPane_ = new TabFolder(compositeBodyPane, SWT.NULL);
	    tabFolderBodyPane_.setLayoutData(gridDataFillBoth);
		createBodyTextPane(tabFolderBodyPane_);
		tabFolderBodyPane_.addSelectionListener( new SelectionListener() {
			public void widgetDefaultSelected(SelectionEvent arg0) {
			}
			public void widgetSelected(SelectionEvent arg0) {
				tabFolderBodyPane_widgetSelected(arg0);
			}
		});
	    
	    // Xe[^Xo[
	    statusBar_ = new Label(shell_, SWT.LEFT | SWT.BORDER);
		GridData gridData = new GridData();
	    gridData.horizontalAlignment = GridData.FILL;
	    statusBar_.setLayoutData(gridData);

	    // j[쐬
	    createMenu();
	    
	    // ACRݒ
	    try {
		    InputStream is = MainFrame.class.getResourceAsStream("glass.png");
		    imageIconSmall_ = new Image(display_, is);
			is.close();

		    is = MainFrame.class.getResourceAsStream("bigglass.png");
		    imageIconBig_ = new Image(display_, is);
			is.close();

		    is = MainFrame.class.getResourceAsStream("bigglass48.png");
		    imageIconBig48_ = new Image(display_, is);
			is.close();
	    } catch (IOException e) {
			e.printStackTrace();
		}
	    
	    shell_.setImages(new Image[] {imageIconSmall_, imageIconBig_});

	    // EBhËʒuȂǂȌԂɖ߂
	    boolean initialized = loadProperties();
	    if (!initialized) {
			// Ȍ񂪂Ȃ̂ŁAԂɂ
		    shell_.setSize(800, 600);
		    horizontalSash_.setWeights(new int[]{1, 5});
	    }
	    
		treeRootItem_.setExpanded(true);
		textSearch_.setFocus();
		
		shell_.open();
	    while (!shell_.isDisposed ()){
	    	if (!display_.readAndDispatch ()){
	    		display_.sleep ();
	    	}
	    }
	    
	    ImageManager.getInstance().dispose();
	    imageIconSmall_.dispose();
	    imageIconBig_.dispose();
	    imageIconBig48_.dispose();
	    display_.dispose();
	}

	/**
	 * c[Ń}EX{^ꂽƂɌĂ΂郁\bh
	 * 
	 * @param e }EXCxg
	 */
	protected void treeSearchCondition__mouseDown(MouseEvent e) {
		if (e.button == 3) {
			// ENbNł́AIĂsȂ
			treeSearchCondition_.removeSelectionListener( treeSearchCondition_SelectionAdapter_ );
		
		} else {
			treeSearchCondition_.removeSelectionListener( treeSearchCondition_SelectionAdapter_ );
			treeSearchCondition_.addSelectionListener( treeSearchCondition_SelectionAdapter_ );
		}
	}

	/**
	 * c[Ń}EX{^ꂽƂɌĂ΂郁\bh
	 * 
	 * @param e }EXCxg
	 */
	protected void treeSearchCondition__mouseUp(MouseEvent e) {
		final TreeItem[] items = treeSearchCondition_.getSelection();
		
		if (items == null || items.length != 1)  return;
		if (items[0].getParentItem() == null)  return;

		if (e.button == 3) {
			// ENbNł́AReLXgj[\

			Menu menu = new Menu(shell_, SWT.POP_UP);
			MenuItem menuItem = new MenuItem (menu, SWT.PUSH);
			menuItem.setText ("폜");
			menuItem.addSelectionListener(new SelectionListener() {
				public void widgetDefaultSelected(SelectionEvent arg0) {
				}

				public void widgetSelected(SelectionEvent arg0) {
					items[0].dispose();

					treeSearchCondition_.setSelection( treeRootItem_ );
				}
			});
			
    		Point cursorLocation = display_.getCursorLocation();
			menu.setLocation (cursorLocation.x, cursorLocation.y);
			menu.setVisible (true);
		}
	}

	/**
	 * {yC̃^ȗIύXꂽƂɌĂ΂郁\bh
	 * 
	 * @param arg0
	 */
	protected void tabFolderBodyPane_widgetSelected(SelectionEvent arg0) {
		if (currentlySelectedDocument_ == null)  return;
		
		if (tabFolderBodyPane_.getSelectionIndex() == 1) {
			// [S]^uIꂽ
			if (textBodyFullText_.getCharCount() > 0)  return;

			if (currentlySelectedDocument_.attr("@uri").startsWith("file")) {
				// ݑIĂ̂́Aʏ̃t@C
				
				if (bodyTextFilePath_.length() == 0)  return;

				File bodyTextFile = Util.convertPathToNativePlatform(bodyTextFilePath_);
		    	if (bodyTextFile == null || !bodyTextFile.exists()) {
					textBodyFullText_.setText(Messages.getString("MainFrame.Error.FileNotFound")); //$NON-NLS-1$
					return;
		    	}
				
			    if (bodyTextFileType_.equals( Constants.TYPE_MSWORD ) 
		    		|| bodyTextFileType_.equals( Constants.TYPE_MSEXCEL ) 
		    		|| bodyTextFileType_.equals( Constants.TYPE_MSPOWERPOINT ) 
		    		|| bodyTextFileType_.equals( Constants.TYPE_PDF ) ) {

			    	// MSItBXt@CBxdoc2txtŕϊĕ\
				    convertAndSetFullText(bodyTextFile);

			    } else {
			    	textBodyFullText_.setText("");
			    	
			    	if (textFileLoadThread_ != null && textFileLoadThread_.isAlive()) {
			    		System.out.println("eLXgǂݍ݃Xbh쒆Ȃ̂ŁA~܂B");
			    		
			    		textFileLoadThread_.stopLoading();
			    	}
			    	
					// ǂݍݒ~{^
			    	if (toolbarSearchWord_.getItemCount() > 0 
			    			&& !toolbarSearchWord_.getItem(0).getText().equals(Constants.TOOLITEM_TEXT_STOP_LOADING)) {
			    		ToolItem item = new ToolItem(toolbarSearchWord_, SWT.PUSH, 0);
			    		item.setText(Constants.TOOLITEM_TEXT_STOP_LOADING);
			    		item.addSelectionListener(new SelectionAdapter() {
							public void widgetSelected(SelectionEvent arg0) {
								toolItemSearchWord_stopTextFileLoading();
							}
			    		});
			    		
			    		new ToolItem(toolbarSearchWord_, SWT.SEPARATOR, 1);
					}

			    	textBodyFullText_.setData(Constants.DATA_LOADING_FILE, bodyTextFile);
			    	textFileLoadThread_ = new TextFileLoadThread(display_, bodyTextFile, textBodyFullText_, toolbarSearchWord_);
					textFileLoadThread_.start();
			    }
			} else {
				// @uri  file: ȊOBƎ̏őS𒊏oE\

				textBodyFullText_.setText( 
						hidemarumail.Util.getMailBodyText( 
								currentlySelectedDocument_ ));
			}
		} else {
			// ȊÕ^uIꂽ
			// eLXgǂݍ݃Xbh쒆ł΁A~
	    	if (textFileLoadThread_ != null && textFileLoadThread_.isAlive()) {
	    		textFileLoadThread_.stopLoading();
	    	}
	    	
	    	if (tabFolderBodyPane_.getSelectionIndex() == 2) {
	    		// [uEU] ^uIĂ

				if (currentlySelectedDocument_.attr("@uri").startsWith("file")) {
					// Gۃ[͑ΏۊO
	    		
		    		String url = browser_.getUrl();
	
		    		if (bodyTextFilePath_.length() > 0) {
			    		if (url == null || url.length() == 0 || url.equals(Constants.BROWSER_BLANK_PAGE)) {
				    		try {
								browser_.setUrl(Util.convertPathToNativePlatform( bodyTextFilePath_ ).toURL().toString());
							} catch (MalformedURLException e) {
								e.printStackTrace();
							}
			    		}
		    		}
				}
	    	}
		}
	}

	/**
	 * MSItBXt@CApdft@Cxdoc2txtŕϊASeLXgRg[ɃZbg郁\bh
	 * 
	 * @param bodyTextFile
	 */
	private void convertAndSetFullText(File bodyTextFile) {
		Cursor waitCursor = new Cursor(null, SWT.CURSOR_WAIT);
		shell_.setCursor(waitCursor);

		try {
			String srcpath = bodyTextFile.getAbsolutePath();
			if (srcpath.indexOf(' ') >= 0)  srcpath = "\"" + srcpath + "\"";
			
			String command = "xdoc2txt " + srcpath;
			Process process = Runtime.getRuntime().exec(command);
			BufferedReader reader = new BufferedReader(new InputStreamReader( process.getInputStream() ));
			
			textBodyFullText_.setRedraw(false);
			textBodyFullText_.setText("");
			
			String line;
			while ((line = reader.readLine()) != null) {
				byte[] bytes = line.getBytes();
				line = new String(bytes, "JISAutoDetect");
				textBodyFullText_.append(line + "\n");
			}
			
			reader.close();
			textBodyFullText_.setRedraw(true);
			
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		shell_.setCursor(null);
		waitCursor.dispose();
	}

	/**
	 * c[Rg[Ń}EX{^ꂽƂɌĂ΂郁\bh
	 * 
	 * @param e
	 */
	protected void treeFileList_mouseUp(MouseEvent e) {
		if (e.button == 3) {
			// ENbN
			TreeItem[] selection = treeFileList_.getSelection();
			if (selection == null || selection.length == 0)  return;
			
			TreeItem selectedItem = selection[0];
			assert selectedItem != null : "Selected item is null.";
			
		    // create the database object
//		    Database db = new Database();

		    // open the database
//		    if (!db.open(indexSettings_.getIndexDataFolder(), Database.DBREADER | Database.DBNOLCK)){
//		    	MessageBox box1 = new MessageBox(shell_, SWT.OK | SWT.ICON_ERROR);
//		    	box1.setMessage(Messages.getString("MainFrame.Error.DatabaseOpening")); //$NON-NLS-1$
//		    	box1.open();
//		    	return;
//		    }
			
//		    int id = ((Integer)selection[0].getData(Constants.DATA_DOCUMENT_ID)).intValue();
//		    Document doc = db.get_doc(id, 0);
//		    
//		    if (!db.close())
//		    	System.err.println("error: " + db.err_msg(db.error()));

		    String uri = (String)selectedItem.getData( Constants.ATTRIBUTE_URI );
		    assert uri != null : "Selected file item does not have URI data.";

		    String realPath = (String)selectedItem.getData( Constants.ATTRIBUTE_REAL_PATH );
		    assert realPath != null : "Selected file item does not have ATTRIBUTE_REAL_PATH data.";
		    
		    if (uri.startsWith("file://")) {
		    	// ʏ̃t@C

			    // u`vƂ̕R[hWindows-31JłȂ̂ŁAϊ
				File targetFile = Util.convertPathToNativePlatform( realPath );
				if (targetFile == null) {
					statusBar_.setText(Messages.getString("MainFrame.Error.FileNotFound")); //$NON-NLS-1$
					return;
				}
				
			    Util.showContextMenu(targetFile.getAbsolutePath());
		    } else {
		    	//TODO IuWFNgwۂ
		    	
		    	if (uri.startsWith("hidemarumail")) {
		    		Point cursorLocation = display_.getCursorLocation();
		    		HidemaruMailPlugin.showPopupMenu(shell_, cursorLocation.x, cursorLocation.y, 
		    				uri, realPath);
		    	}
		    }
		}
	}

	/**
	 * EBhETCYꂽƂɌĂ΂郁\bh
	 * 
	 * @param arg0
	 */
	protected void shell_controlResized(ControlEvent arg0) {
		if (!shell_.getMaximized() && !shell_.getMinimized()) {
			rectNormal_ = shell_.getBounds();
		}
	}

	/**
	 * EBhEړꂽƂɌĂ΂郁\bh
	 * 
	 * @param arg0
	 */
	protected void shell_controlMoved(ControlEvent arg0) {
		if (!shell_.getMaximized() && !shell_.getMinimized()) {
			rectNormal_ = shell_.getBounds();
		}
	}

	/**
	 * {\̈쐬郁\bh
	 * 
	 * @param tabFolder Rg[zueƂȂTabFolder
	 */
	private void createBodyTextPane(TabFolder tabFolder) {
        GridData gridDataFillHorizontal = new GridData(GridData.FILL_HORIZONTAL);
		GridData gridDataFillBoth = new GridData(GridData.FILL_BOTH);
	    GridLayout l = new GridLayout(1, false);

        // [Tv] ^u쐬
		{
		    TabItem item1 = new TabItem(tabFolder, SWT.NULL);
		    item1.setText(Messages.getString("MainFrame.Tab.Summary")); //$NON-NLS-1$
	
		    Composite c2 = new Composite(tabFolder, SWT.NULL);
		    c2.setLayout(l);
	
		    // c[o[̗̈
		    Composite canvas = new Composite(c2, SWT.NONE);
		    GridLayout layout = new GridLayout(5, false);
	        layout.horizontalSpacing = HORIZONTAL_SPACING;
	        layout.marginWidth = MARGIN_WIDTH;
	        layout.marginHeight = MARGIN_HEIGHT;
	        canvas.setLayout(layout);
	        canvas.setLayoutData(gridDataFillHorizontal);
	        
	        Label label = new Label(canvas, SWT.NULL);
	        label.setText(Messages.getString("MainFrame.Tab.Summary.Cap1")); //$NON-NLS-1$
	        
	        spinnerSummaryCount_ = new Spinner(canvas, SWT.BORDER);
			spinnerSummaryCount_.setSelection(90);
	        spinnerSummaryCount_.setMaximum(10000);
	        spinnerSummaryCount_.addModifyListener(new ModifyListener() {
				public void modifyText(ModifyEvent arg0) {
					spinnerSummaryCount_modifyText(arg0);
				}
	        });
	
	        Label label2 = new Label(canvas, SWT.NULL);
	        label2.setText(Messages.getString("MainFrame.Tab.Summary.Cap2")); //$NON-NLS-1$
	
		    textBodySummary_ = new StyledText(c2, SWT.MULTI | SWT.BORDER | SWT.H_SCROLL | SWT.V_SCROLL);
		    textBodySummary_.setEditable(false);
		    textBodySummary_.setBackground(new Color(display_, 255, 255, 255));
		    textBodySummary_.setWordWrap(true);
		    textBodySummary_.setLayoutData(gridDataFillBoth);
			
		    item1.setControl(c2);
		}

        // [S] ^u쐬
		{
		    TabItem item2 = new TabItem(tabFolder, SWT.NULL);
		    item2.setText(Messages.getString("MainFrame.Tab.FullText")); //$NON-NLS-1$
		    
		    Composite c = new Composite(tabFolder, SWT.NULL);
		    c.setLayout(l);
		    toolbarSearchWord_ = new ToolBar(c, SWT.NULL);
		    RowLayout rlayout = new RowLayout(SWT.HORIZONTAL);
		    rlayout.spacing = 10;
		    rlayout.marginWidth = 10;
		    toolbarSearchWord_.setLayout(rlayout);
		    toolbarSearchWord_.setLayoutData(gridDataFillHorizontal);
			
		    // {̈
		    textBodyFullText_ = new StyledText(c, SWT.MULTI | SWT.BORDER | SWT.H_SCROLL | SWT.V_SCROLL);
		    textBodyFullText_.setEditable(false);
		    textBodyFullText_.setBackground(new Color(display_, 255, 255, 255));
		    textBodyFullText_.setWordWrap(true);
		    textBodyFullText_.setLayoutData(gridDataFillBoth);
		    
		    item2.setControl(c);
		}
		
        // [uEU] ^u쐬
		{
		    TabItem item1 = new TabItem(tabFolder, SWT.NULL);
		    item1.setText(Messages.getString("MainFrame.Tab.WebBrowser")); //$NON-NLS-1$

		    Composite c2 = new Composite(tabFolder, SWT.NULL);
		    c2.setLayout(l);

		    toolbarSearchWordBrowser_ = new ToolBar(c2, SWT.NULL);
			RowLayout rlayout = new RowLayout(SWT.HORIZONTAL);
		    rlayout.spacing = 10;
		    rlayout.marginWidth = 10;
		    toolbarSearchWordBrowser_.setLayout(rlayout);
		    toolbarSearchWordBrowser_.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));

	    	try {
	    		browser_ = new Browser(c2, SWT.BORDER);
	    		
			    browser_.setLayoutData(new GridData(GridData.FILL_BOTH));
	    	} catch (Exception ex) {
		    	MessageBox box1 = new MessageBox(shell_, SWT.OK | SWT.ICON_ERROR);
		    	box1.setMessage(Messages.getString("MainFrame.Error.BrowserComponent") + ex.getLocalizedMessage()); //$NON-NLS-1$
		    	box1.open();
	    	}
	    	
		    item1.setControl( c2 );
		}
	}
	
	/**
	 * "Tv"^uŃXsRg[̒lύXꂽƂɌĂ΂郁\bh
	 * 
	 * @param arg0
	 */
	protected void spinnerSummaryCount_modifyText(ModifyEvent arg0) {
		if (textSearch_.getText().length() == 0 || treeFileList_.getSelectionCount() == 0)  return;
		
		TreeItem[] selection = treeFileList_.getSelection();
		
		assert selection != null && selection.length >= 1;
		
	    Database db = new Database();

	    // open the database
	    if (!db.open(indexSettings_.getIndexDataFolder(), Database.DBREADER | Database.DBNOLCK)){
	    	MessageBox box1 = new MessageBox(shell_, SWT.OK | SWT.ICON_ERROR);
	    	box1.setMessage(Messages.getString("MainFrame.Error.DatabaseOpening")); //$NON-NLS-1$
	    	box1.open();
	    	return;
	    }
		
	    int id = ((Integer)selection[0].getData(Constants.DATA_DOCUMENT_ID)).intValue();
	    Document doc = db.get_doc(id, 0);

    	String summary = MainProcedure.getSummaryText(doc, textSearch_.getText(), spinnerSummaryCount_.getSelection());
		textBodySummary_.setText(summary);
		
		db.close();
		
//		if (textBodySummary_.getText().length() == 0)  return;
	
//		search();
//		treeFileList_widgetSelected(null);
	}

	/**
	 * t@Cꗗc[ŃL[ꂽƂɌĂ΂郁\bh
	 * 
	 * @param arg0 L[Cxg
	 */
	protected void treeFileList_keyPressed(KeyEvent arg0) {
		if (arg0.keyCode == SWT.CR) {
			popupMenuItemOpen_widgetSelected(null);
		}
	}

	/**
	 * c[ŃL[ꂽƂɌĂ΂郁\bh
	 * 
	 * @param arg0 L[Cxg
	 */
	protected void treeSearchCondition_keyPressed(KeyEvent arg0) {
		if (arg0.keyCode == SWT.DEL) {
			TreeItem[] items = treeSearchCondition_.getSelection();
			
			assert(items != null);
			assert(items.length == 1);
			
			if (items[0].getParentItem() == null)  return;
			
			items[0].dispose();
		}
	}

	/**
	 * t@Cꗗc[_uNbNꂽƂɌĂ΂郁\bh
	 * 
	 * @param arg0 }EXCxg
	 */
	protected void treeFileList_mouseDoubleClick(MouseEvent arg0) {
		popupMenuItemOpen_widgetSelected(null);
	}

	/**
	 * c[̍ڂIꂽƂɌĂ΂郁\bh
	 * 
	 * @param arg0 ZNgCxg
	 */
	protected void treeSearchCondition_widgetSelected(SelectionEvent arg0) {
//		System.out.println("treeSearchCondition_widgetSelected");
		
		TreeItem[] items = treeSearchCondition_.getSelection();
		
		assert(items != null);
		assert(items.length == 1);
		
		if (items[0].getParentItem() == null)  return;
		
		textSearch_.setText(items[0].getText());
		textSearch_.setSelection(0, textSearch_.getText().length() + 1);

		search(items[0].getText());
	}

	/**
	 * EBhEƂɌĂ΂郁\bh
	 * 
	 * @param arg0 VFCxg
	 */
	protected void shell_shellClosed(ShellEvent arg0) {
		// eLXgǂݍ݃Xbh쒆ł΁A~
    	if (textFileLoadThread_ != null && textFileLoadThread_.isAlive()) {
    		textFileLoadThread_.stopLoading();
    	}

		saveProperties();
	}

	/**
	 * EBhETCYAݒlvpeBt@CɋL^郁\bh
	 */
	private void saveProperties() {
		String filepath = Util.getPropertyFilePath();

		// fBNg쐬
		new File(filepath.substring(0, filepath.lastIndexOf(File.separator))).mkdirs();

		Properties prop;
		try{
			FileOutputStream out = new FileOutputStream(filepath);
			prop = new Properties();

			// 
			if (!shell_.getMaximized() && !shell_.getMinimized()) {
				rectNormal_ = shell_.getBounds();
			}
			
			prop.setProperty("X", String.valueOf(rectNormal_.x));
			prop.setProperty("Y", String.valueOf(rectNormal_.y));
			prop.setProperty("Width", String.valueOf(rectNormal_.width));
			prop.setProperty("Height", String.valueOf(rectNormal_.height));
			prop.setProperty("spinnerSummaryCount_Selection", String.valueOf( spinnerSummaryCount_.getSelection() ));
			prop.setProperty("checkOrderDate_Selection", String.valueOf( checkOrderDate_.getSelection() ));
			prop.setProperty("shell_Maximized", String.valueOf( shell_.getMaximized() ));
			prop.setProperty("shell_Minimized", String.valueOf( shell_.getMinimized() ));
			
			{
				int[] hsweights = horizontalSash_.getWeights();
				for (int i=0; i<hsweights.length; i++) {
					prop.setProperty("horizontalSash_weight" + i, String.valueOf(hsweights[i]));
				}
			}

			{
				int[] vsweights = verticalSash_.getWeights();
				for (int i=0; i<vsweights.length; i++) {
					prop.setProperty("verticalSash_weight" + i, String.valueOf(vsweights[i]));
				}
			}

			{
				TreeColumn[] cols = treeFileList_.getColumns();
				for (int i=0; i<cols.length; i++) {
					prop.setProperty("column_width" + i, String.valueOf(cols[i].getWidth()));
				}
			}
			
			{
				TreeItem[] items = treeRootItem_.getItems();
				for (int i=0; i<items.length; i++) {
					prop.setProperty("TreeItem" + i, String.valueOf(items[i].getText()));
				}
			}
			
			indexSettings_.save(prop);
			generalSettings_.save(prop);
			advancedIndexSettingModel_.save(prop);
			
			prop.store(out, "");
			
			out.close();
		} catch (Exception er) {
			er.printStackTrace();
		}
	}

	/**
	 * j[쐬郁\bh
	 */
	private void createMenu() {
	    Menu menubar = new Menu(shell_, SWT.BAR);
	    shell_.setMenuBar(menubar);
	    
	    MenuItem menuItemFile = new MenuItem(menubar, SWT.CASCADE);
	    menuItemFile.setText(Messages.getString("MainFrame.Menu.File")); //$NON-NLS-1$
	    
	    Menu menu1 = new Menu(menuItemFile);
	    menuItemFile.setMenu(menu1);
	    
	    menuItemFile.addArmListener(new ArmListener() {
			public void widgetArmed(ArmEvent arg0) {
//				System.out.println("widgetArmed");
				menuItemFile_widgetArmed(arg0);
			}
	    });
	    menuItemFile.addSelectionListener(new SelectionListener() {
			public void widgetSelected(SelectionEvent arg0) {
				System.out.println("widgetSelected");
			}

			public void widgetDefaultSelected(SelectionEvent arg0) {
			}
	    });

	    menuitemFile_StartIndexing_ = new MenuItem(menu1, SWT.PUSH);
		menuitemFile_StartIndexing_.setText(Messages.getString("MainFrame.Menu.File.StartIndexing")); //$NON-NLS-1$
	    menuitemFile_StartIndexing_.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent arg0) {
				menuitemFileStartIndexing_widgetSelected(arg0);
			}
	    });
	    
	    menuitemFile_PurgeIndex_ = new MenuItem(menu1, SWT.PUSH);
		menuitemFile_PurgeIndex_.setText(Messages.getString("MainFrame.Menu.File.Purge")); //$NON-NLS-1$
	    menuitemFile_PurgeIndex_.addSelectionListener(new SelectionAdapter() {
	    	public void widgetSelected(SelectionEvent arg0) {
	    		menuitemFilePurgeIndex_widgetSelected(arg0);
	    	}
	    });

	    menuitemFile_ExtractKeywords_ = new MenuItem(menu1, SWT.PUSH);
		menuitemFile_ExtractKeywords_.setText(Messages.getString("MainFrame.Menu.File.ExtractKeyword")); //$NON-NLS-1$
	    menuitemFile_ExtractKeywords_.addSelectionListener(new SelectionAdapter() {
	    	public void widgetSelected(SelectionEvent arg0) {
	    		menuitemFileExtractKeywords_widgetSelected(arg0);
	    	}
	    });

	    menuitemFile_OptimizeIndex_ = new MenuItem(menu1, SWT.PUSH);
		menuitemFile_OptimizeIndex_.setText(Messages.getString("MainFrame.Menu.File.Optimize")); //$NON-NLS-1$
	    menuitemFile_OptimizeIndex_.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent arg0) {
				menuitemFileOptimizeIndex_widgetSelected(arg0);
			}
	    });

	    new MenuItem(menu1, SWT.SEPARATOR);
	    
	    MenuItem menuitemFileQuit = new MenuItem(menu1, SWT.PUSH);
	    menuitemFileQuit.setText(Messages.getString("MainFrame.Menu.File.Quit")); //$NON-NLS-1$
	    menuitemFileQuit.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent arg0) {
				menuitemFileQuit_widgetSelected(arg0);
			}
	    });
	    
	    MenuItem itemSetting = new MenuItem(menubar, SWT.CASCADE);
	    itemSetting.setText(Messages.getString("MainFrame.Menu.Setting")); //$NON-NLS-1$

	    Menu menuSetting = new Menu(itemSetting);
	    itemSetting.setMenu(menuSetting);

	    MenuItem itemSetting_GeneralSetting = new MenuItem(menuSetting, SWT.PUSH);
	    itemSetting_GeneralSetting.setText(Messages.getString("MainFrame.Menu.Setting.General")); //$NON-NLS-1$
	    itemSetting_GeneralSetting.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent arg0) {
				menuItemSetting_GeneralSetting_widgetSelected(arg0);
			}
	    });

	    MenuItem menuitemSelectDirectories = new MenuItem(menuSetting, SWT.PUSH);
	    menuitemSelectDirectories.setText(Messages.getString("MainFrame.Menu.Setting.Index")); //$NON-NLS-1$
	    menuitemSelectDirectories.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent arg0) {
				menuitemSetting_IndexSetting_widgetSelected(arg0);
			}
	    });

	    MenuItem menuitemAdvancedIndexSetting = new MenuItem(menuSetting, SWT.PUSH);
	    menuitemAdvancedIndexSetting.setText(Messages.getString("MainFrame.Menu.Setting.IndexAdvanced")); //$NON-NLS-1$
	    menuitemAdvancedIndexSetting.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent arg0) {
				menuitemSetting_AdvancedIndexSetting_widgetSelected(arg0);
			}
	    });

	    MenuItem itemHelp = new MenuItem(menubar, SWT.CASCADE);
	    itemHelp.setText(Messages.getString("MainFrame.Menu.Help")); //$NON-NLS-1$

	    Menu menuHelp = new Menu(itemHelp);
	    itemHelp.setMenu(menuHelp);

	    MenuItem itemHelp_GotoWeb = new MenuItem(menuHelp, SWT.PUSH);
	    itemHelp_GotoWeb.setText(Messages.getString("MainFrame.Menu.Help.OpenWebPage")); //$NON-NLS-1$
	    itemHelp_GotoWeb.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent arg0) {
				menuItemHelp_GotoWeb_widgetSelected(arg0);
			}
	    });

	    new MenuItem(menuHelp, SWT.SEPARATOR);

	    MenuItem itemHelp_About = new MenuItem(menuHelp, SWT.PUSH);
	    itemHelp_About.setText(Messages.getString("MainFrame.Menu.Help.About")); //$NON-NLS-1$
	    itemHelp_About.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent arg0) {
				menuItemHelp_About_widgetSelected(arg0);
			}
	    });
	}

	/**
	 * [t@C]j[\ƂɌĂ΂郁\bh
	 * 
	 * @param arg0
	 */
	protected void menuItemFile_widgetArmed(ArmEvent arg0) {
		boolean indexing = Util.isIndexing();
		
		menuitemFile_StartIndexing_.setEnabled(!indexing);
		menuitemFile_PurgeIndex_.setEnabled(!indexing);
		menuitemFile_ExtractKeywords_.setEnabled(!indexing);
		menuitemFile_OptimizeIndex_.setEnabled(!indexing);
	}

	/**
	 * [㋉ҌCfbNXݒ]I΂ꂽƂɌĂ΂郁\bh
	 * 
	 * @param arg0
	 */
	protected void menuitemSetting_AdvancedIndexSetting_widgetSelected(SelectionEvent arg0) {
		AdvancedIndexSettingDialog dialog = new AdvancedIndexSettingDialog(shell_, advancedIndexSettingModel_);

		AdvancedIndexSettingModel settings = dialog.open();
		if (settings == null)  return;
		
		advancedIndexSettingModel_ = settings;
	}

	/**
	 * [L[[ho]IɌĂ΂郁\bh
	 * 
	 * @param arg0
	 */
	protected void menuitemFileExtractKeywords_widgetSelected(SelectionEvent arg0) {
		try {
			File tempFile = File.createTempFile("dhe", null);
			tempFile.deleteOnExit();
			
			BufferedWriter writer = new BufferedWriter(new FileWriter( tempFile ));

			String indexPath = indexSettings_.getIndexDataFolder();
			if (indexPath.indexOf(' ') >= 0) {
				// CfbNXf[^i[tH_̃pXɃXy[X܂܂̂ŁANH[e[Vň͂ށB
				indexPath = "\"" + indexPath + "\"";
			}

			String command = advancedIndexSettingModel_.getExtractKeywordsCommand();
			command += " " + indexPath;
			
			writer.write(command + "\n");
			writer.write(Messages.getString("MainFrame.Message.KeywordExtracting")); //$NON-NLS-1$
			
			writer.close();
			
			Runtime.getRuntime().exec("Indexer \"" + tempFile.getAbsolutePath() + "\"");
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	/**
	 * [SʓIȐݒ]IꂽƂɌĂ΂郁\bh
	 * 
	 * @param arg0
	 */
	protected void menuItemSetting_GeneralSetting_widgetSelected(SelectionEvent arg0) {
		GeneralSettingDialog dialog = new GeneralSettingDialog(shell_, generalSettings_);

		GeneralSettingsModel settings = dialog.open();
		if (settings == null)  return;
		
		generalSettings_ = settings;
		textBodyFullText_.setFont(new Font(display_, generalSettings_.getFontDataBody()));
		textBodySummary_.setFont(new Font(display_, generalSettings_.getFontDataBody()));
	}

	/**
	 * [z[y[WJ]IɌĂ΂郁\bh
	 * 
	 * @param arg0
	 */
	protected void menuItemHelp_GotoWeb_widgetSelected(SelectionEvent arg0) {
		Program.launch("http://freemind.s57.xrea.com/desktophe/index.html");
	}

	/**
	 * j[[폜t@C]IɌĂ΂郁\bh
	 * 
	 * @param arg0 ZNVCxg
	 */
	protected void menuitemFilePurgeIndex_widgetSelected(SelectionEvent arg0) {
		try {
			File tempFile = File.createTempFile("dhe", null);
			tempFile.deleteOnExit();
			
			BufferedWriter writer = new BufferedWriter(new FileWriter( tempFile ));

			String indexPath = indexSettings_.getIndexDataFolder();
			if (indexPath.indexOf(' ') >= 0) {
				// CfbNXf[^i[tH_̃pXɃXy[X܂܂̂ŁANH[e[Vň͂ށB
				indexPath = "\"" + indexPath + "\"";
			}

			String command = advancedIndexSettingModel_.getPurgeCommand();
			command += " " + indexPath;
			
			writer.write(command + "\n");
			writer.write(Messages.getString("MainFrame.Message.Purging")); //$NON-NLS-1$
			
			writer.close();
			
			Runtime.getRuntime().exec("Indexer \"" + tempFile.getAbsolutePath() + "\"");
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	/**
	 * j[[o[W]IɌĂ΂郁\bh
	 * 
	 * @param arg0 ZNVCxg
	 */
	protected void menuItemHelp_About_widgetSelected(SelectionEvent arg0) {
		Properties properties = System.getProperties();
		Iterator iterator = properties.keySet().iterator();
		while (iterator.hasNext()) {
			String key = (String) iterator.next();
			System.out.println(key + ": " + properties.getProperty(key));
		}
		
		
		AboutDialog dlg = new AboutDialog(shell_);
		dlg.open();
	}

	/**
	 * e[ü̃|bvAbvj[ŁA[tH_J]I΂ꂽƂɌĂ΂郁\bh
	 * 
	 * @param arg0 ZNVCxg
	 */
	protected void popupMenuItemOpenFolder_widgetSelected(SelectionEvent arg0) {
		TreeItem[] selection = treeFileList_.getSelection();
		if (selection == null || selection.length == 0)  return;
		
	    // create the database object
	    Database db = new Database();

	    // open the database
	    if (!db.open(indexSettings_.getIndexDataFolder(), Database.DBREADER | Database.DBNOLCK)) {
	    	MessageBox box1 = new MessageBox(shell_, SWT.OK | SWT.ICON_ERROR);
	    	box1.setMessage(Messages.getString("MainFrame.Error.DatabaseOpening")); //$NON-NLS-1$
	    	box1.open();
	    	return;
	    }
		
	    Cursor waitCursor = new Cursor(null, SWT.CURSOR_WAIT);
	    shell_.setCursor(waitCursor);

	    int id = ((Integer)selection[0].getData(Constants.DATA_DOCUMENT_ID)).intValue();
	    Document doc = db.get_doc(id, Database.GDNOTEXT);

	    String folder = doc.attr( Constants.ATTRIBUTE_REAL_PATH );
	    folder = folder.substring(0, folder.lastIndexOf(File.separator));
	    
	    // close the database
	    if (!db.close()) {
	    	System.err.println("error: " + db.err_msg(db.error()));
	    }

	    Program.launch(folder);

    	shell_.setCursor(null);
	    waitCursor.dispose();
	}

	/**
	 * e[ü̃|bvAbvj[ŁA[J]I΂ꂽƂɌĂ΂郁\bh
	 * 
	 * @param arg0 ZNVCxg
	 */
	protected void popupMenuItemOpen_widgetSelected(SelectionEvent arg0) {
		TreeItem[] selection = treeFileList_.getSelection();
		if (selection == null || selection.length == 0)  return;
		
	    // create the database object
	    Database db = new Database();

	    // open the database
	    if (!db.open(indexSettings_.getIndexDataFolder(), Database.DBREADER | Database.DBNOLCK)) {
	    	MessageBox box1 = new MessageBox(shell_, SWT.OK | SWT.ICON_ERROR);
	    	box1.setMessage(Messages.getString("MainFrame.Error.DatabaseOpening")); //$NON-NLS-1$
	    	box1.open();
	    	return;
	    }
		
	    Cursor waitCursor = new Cursor(null, SWT.CURSOR_WAIT);
	    shell_.setCursor(waitCursor);

	    int id = ((Integer)selection[0].getData(Constants.DATA_DOCUMENT_ID)).intValue();
	    Document doc = db.get_doc(id, Database.GDNOTEXT);
	    String uri = doc.attr( Constants.ATTRIBUTE_URI );
	    String path = doc.attr( Constants.ATTRIBUTE_REAL_PATH );
	    
	    // close the database
	    if (!db.close()) {
	    	System.err.println("error: " + db.err_msg(db.error()));
	    }
	    
	    if (uri.startsWith("file://")) {
	    	// ʏ̃t@CBGNXv[Ń_uNbNƂƓlɂ
	    	
		    if (!(new File(path)).isFile()) {
		    	try {
		    		path = new String( path.getBytes("Shift_JIS") );
				} catch (UnsupportedEncodingException e) {
					e.printStackTrace();
				}
		    }

		    Program.launch(path);
	    } else {
	    	//TODO IuWFNgwۂ 
	    	
	    	if (uri.startsWith("hidemarumail:")) {
	    		HidemaruMailPlugin.openDocument(doc);
	    	}
	    }

    	shell_.setCursor(null);
	    waitCursor.dispose();
	}

	/**
	 * j[[I]I΂ꂽƂɌĂ΂郁\bh
	 * 
	 * @param arg0 ZNVCxg
	 */
	protected void menuitemFileQuit_widgetSelected(SelectionEvent arg0) {
		shell_.close();
	}

	/**
	 * j[[CfbNXœK]I΂ꂽƂɌĂ΂郁\bh
	 * 
	 * @param arg0 ZNVCxg
	 */
	protected void menuitemFileOptimizeIndex_widgetSelected(SelectionEvent arg0) {
		try {
			File tempFile = File.createTempFile("dhe", null);
			tempFile.deleteOnExit();
			
			BufferedWriter writer = new BufferedWriter(new FileWriter( tempFile ));

			String indexPath = indexSettings_.getIndexDataFolder();
			if (indexPath.indexOf(' ') >= 0) {
				// CfbNXf[^i[tH_̃pXɃXy[X܂܂̂ŁANH[e[Vň͂ށB
				indexPath = "\"" + indexPath + "\"";
			}

			String command = advancedIndexSettingModel_.getOptimizeCommand();
			command += " " + indexPath;
			
			writer.write(command + "\n");
			writer.write(Messages.getString("MainFrame.Message.Optimizing")); //$NON-NLS-1$
			
			writer.close();
			
			Runtime.getRuntime().exec("Indexer \"" + tempFile.getAbsolutePath() + "\"");
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	/**
	 * j[[CfbNXJn]I΂ꂽƂɌĂ΂郁\bh
	 * 
	 * @param arg0 ZNVCxg
	 */
	protected void menuitemFileStartIndexing_widgetSelected(SelectionEvent arg0) {
		if (indexSettings_.getTargetFolderList().size() == 0) {
			MessageBox box = new MessageBox(shell_, SWT.OK | SWT.ICON_WARNING);
			box.setMessage(Messages.getString("MainFrame.Error.TargetDirectoryNotSet")); //$NON-NLS-1$
			box.open();
			return;
		}
		
		// CfbNXi[̃tH_݂Ă邩ׁA݂ĂȂꍇ͍쐬
		{
			File indexDataFolder = new File(indexSettings_.getIndexDataFolder());
			if (!indexDataFolder.exists()) {
				indexDataFolder.mkdirs();
			}
		}
		
		String indexPath = indexSettings_.getIndexDataFolder();
		if (indexPath.indexOf(' ') >= 0) {
			// CfbNXf[^i[tH_̃pXɃXy[X܂܂̂ŁANH[e[Vň͂ށB
			indexPath = "\"" + indexPath + "\"";
		}

		try {
			File tempFile = File.createTempFile("dhe", null);
			tempFile.deleteOnExit();
			
			BufferedWriter writer = new BufferedWriter(new FileWriter( tempFile ));

			// WŃT|[gĂt@C̃CfbNX
			{
				String command = advancedIndexSettingModel_.getIndexCommand();
				command += " " + indexPath + " ";
				
				for (int i=0; i<indexSettings_.getTargetFolderList().size(); i++) {
					String dir = (String)indexSettings_.getTargetFolderList().get(i);

					if (dir.indexOf(' ') >= 0) {
						// tH_̃pXɃXy[X܂܂̂ŁANH[e[Vň͂ށB
						dir = "\"" + dir + "\"";
					}
					
					writer.write(command + dir + "\n");
					writer.write("[" + dir + "] " + Messages.getString("MainFrame.IndexingDescription1")); //$NON-NLS-1$
				}
			}
			
			// xdoc2txtgpẴCfbNX
			{
				String command = advancedIndexSettingModel_.getIndexOfficeFileCommand();
				command += " " + indexPath + " ";
				
				for (int i=0; i<indexSettings_.getTargetFolderList().size(); i++) {
					String dir = (String)indexSettings_.getTargetFolderList().get(i);

					if (dir.indexOf(' ') >= 0) {
						// tH_̃pXɃXy[X܂܂̂ŁANH[e[Vň͂ށB
						dir = "\"" + dir + "\"";
					}
					
					writer.write(command + dir + "\n");
					writer.write("[" + dir + "] " + Messages.getString("MainFrame.IndexingDescription2")); //$NON-NLS-1$
				}
			}
			
			// ǉ̊gq̏
			if (indexSettings_.isAddTextExtension()) {
				indexAdditionalFiles('T', indexSettings_.getAdditionalTextExtension(), writer);				
			}

			if (indexSettings_.isAddHtmlExtension()) {
				indexAdditionalFiles('H', indexSettings_.getAdditionalHtmlExtension(), writer);				
			}

			if (indexSettings_.isAddMimeExtension()) {
				indexAdditionalFiles('M', indexSettings_.getAdditionalMimeExtension(), writer);				
			}
			
			StringBuffer commandBuffer = new StringBuffer();

			// Firefox̃LbVCfbNX
			if (indexSettings_.isIndexFirefoxCache()) {
				FirefoxPlugin plugin = new FirefoxPlugin();
				plugin.appendIndexCommand( commandBuffer );
			}
			
			// Gۃ[
			if (indexSettings_.isIndexHidemaruMail()) {
				HidemaruMailPlugin plugin = new HidemaruMailPlugin();
				plugin.appendIndexCommand( commandBuffer );
			}
			
			if (commandBuffer.length() > 0) {
				String command = replaceKeywords( commandBuffer );
				writer.write( command );
			}
			
			writer.close();
			
			Runtime.getRuntime().exec("Indexer \"" + tempFile.getAbsolutePath() + "\"");
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	/**
	 * vOCp̃CfbNXR}h́AL[[hu郁\bh
	 * 
	 * @param buffer
	 * @return
	 */
	private String replaceKeywords(StringBuffer buffer) {
		String src = buffer.toString();
		
		if (src.indexOf("%INDEX_DIRECTORY%") >= 0) {
			String indexPath = indexSettings_.getIndexDataFolder();
			if (indexPath.indexOf(' ') >= 0) {
				// CfbNXf[^i[tH_̃pXɃXy[X܂܂̂ŁANH[e[Vň͂ށB
				indexPath = "\"" + indexPath + "\"";
			}
			
			src = Util.replaceString(src, "%INDEX_DIRECTORY%", indexPath);
		}
		
		src = Util.replaceString(src, "%PROFILE_DIRECTORY%", Util.getSettingDataFolder());
		
		if (src.indexOf("%JAVA_EXE%") >= 0) {
			String javaExePath = Util.getJavaExePath();
			if (javaExePath.indexOf(' ') >= 0) {
				// CfbNXf[^i[tH_̃pXɃXy[X܂܂̂ŁANH[e[Vň͂ށB
				javaExePath = "\"" + javaExePath + "\"";
			}
			
			src = Util.replaceString(src, "%JAVA_EXE%", javaExePath);
		}
		
		if (src.indexOf("%CLASS_PATH%") >= 0) {
			String classpath = System.getProperty("classpath");

			src = Util.replaceString(src, "%CLASS_PATH%", classpath);
		}
		
		return src;
	}

	private void indexAdditionalFiles(char typeChar, String extension, Writer writer) throws IOException {
		// ǉ̃t@CCfbNX
		String indexPath = indexSettings_.getIndexDataFolder();
		if (indexPath.indexOf(' ') >= 0) {
			// CfbNXf[^i[tH_̃pXɃXy[X܂܂̂ŁANH[e[Vň͂ށB
			indexPath = "\"" + indexPath + "\"";
		}
		
		String command = "estcmd gather -cl -fx ";
		command += extension;
		command += " ";
		command += typeChar;
		command += "@nothingfilter -fz -il ja -pc CP932 -sd -cm ";
		command	+= indexPath;
		command	+= " ";
		
		for (int i=0; i<indexSettings_.getTargetFolderList().size(); i++) {
			String dir = (String)indexSettings_.getTargetFolderList().get(i);
			
			if (dir.indexOf(' ') >= 0) {
				// tH_̃pXɃXy[X܂܂̂ŁANH[e[Vň͂ށB
				dir = "\"" + dir + "\"";
			}

			writer.write(command + dir + "\n");
			writer.write("[" + dir + "] " + Messages.getString("MainFrame.IndexingDescription3")); //$NON-NLS-1$
		}
	}

	/**
	 * j[[CfbNXݒ]I΂ꂽƂɌĂ΂郁\bh
	 * 
	 * @param arg0 ZNVCxg
	 */
	protected void menuitemSetting_IndexSetting_widgetSelected(SelectionEvent arg0) {
		IndexSettingDialog dialog = new IndexSettingDialog(shell_);
		dialog.setData(indexSettings_);

		IndexSettingsModel newSetting = dialog.open();
		
		if (newSetting == null)  return;
		
		IndexSettingManager indexSettingManager = new IndexSettingManager(indexSettings_, newSetting);
		
		// łɃCfbNXsĂACfbNXΏۂOꂽtH_ꍇ́ȀCfbNX폜
		{
			List removedFolderList = indexSettingManager.getRemovedTargetFolderList();
			
			if ((new File(newSetting.getIndexDataFolder())).isDirectory() && removedFolderList.size() > 0) {
				ProgressDialog dlg = new ProgressDialog(shell_);
				dlg.open();
				
				Thread t = new RemoveTargetFolderThread(display_, dlg, removedFolderList, newSetting);
				t.start();
			}
		}
		
		// CfbNXΏۂOꂽgqꍇ́ȀCfbNX폜
		{
			List removedExtensionList = new ArrayList();
			
			List list = indexSettingManager.getRemovedTextExtension();
			for (int i=0; i<list.size(); i++) {
				removedExtensionList.add((String)list.get(i));
			}
			
			list = indexSettingManager.getRemovedHtmlExtension();
			for (int i=0; i<list.size(); i++) {
				removedExtensionList.add((String)list.get(i));
			}

			list = indexSettingManager.getRemovedMimeExtension();
			for (int i=0; i<list.size(); i++) {
				removedExtensionList.add((String)list.get(i));
			}
			
			if (removedExtensionList.size() > 0) {
				ProgressDialog dlg = new ProgressDialog(shell_);
				dlg.open();
				
				Thread t = new RemoveAdditionalExtensionThread(display_, dlg, removedExtensionList, newSetting);
				t.start();
			}
		}
		
		// ʏ̃CfbNXf[^ɂāAȑO`FbNĂ̂A`FbNOĂꍇA
		// CfbNXf[^폜邩q˂
		{
			String indexPath = indexSettings_.getIndexDataFolder();
			if (indexPath.indexOf(' ') >= 0) {
				// CfbNXf[^i[tH_̃pXɃXy[X܂܂̂ŁANH[e[Vň͂ށB
				indexPath = "\"" + indexPath + "\"";
			}

			StringBuffer deleteCommand = new StringBuffer();

			// Firefox̃LbVCfbNXȂݒɂȂĂA폜邩mF
			if (indexSettings_.isIndexFirefoxCache() && !newSetting.isIndexFirefoxCache()) {
				FirefoxPlugin firefoxPlugin = new FirefoxPlugin();
				MessageBox box3 = new MessageBox(shell_, SWT.YES | SWT.NO | SWT.ICON_QUESTION);
				box3.setMessage( firefoxPlugin.getDeleteConfirmMessage() );
				int ret = box3.open();
				
				if (ret == SWT.YES) {
					firefoxPlugin.appendPurgeCommand(indexPath, deleteCommand);
				}
			}
			
			// Gۃ[̃f[^CfbNXȂݒɂȂĂA폜邩mF
			if (indexSettings_.isIndexHidemaruMail() && !newSetting.isIndexHidemaruMail()) {
				HidemaruMailPlugin plugin = new HidemaruMailPlugin();
				MessageBox box3 = new MessageBox(shell_, SWT.YES | SWT.NO | SWT.ICON_QUESTION);
				box3.setMessage( plugin.getDeleteConfirmMessage() );
				int ret = box3.open();
				
				if (ret == SWT.YES) {
					plugin.appendPurgeCommand(indexPath, deleteCommand);
				}
			}

			if (deleteCommand.length() > 0) {
				try {
					File tempFile = File.createTempFile("dhe", null);
					tempFile.deleteOnExit();
					
					BufferedWriter writer = new BufferedWriter(new FileWriter( tempFile ));
					writer.write(deleteCommand.toString());
					writer.close();
					
					Runtime.getRuntime().exec("Indexer \"" + tempFile.getAbsolutePath() + "\"");
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}
		
		indexSettings_ = newSetting;
	}

	/**
	 * c[o[쐬郁\bh
	 *
	 * @param com c[o[Ƃč쐬ꂽComposite
	 */
	private void createToolbar(Composite com) {
        Label l = new Label(com, SWT.NONE);
        l.setText(Messages.getString("MainFrame.Toolbar.SearchWords")); //$NON-NLS-1$
        
	    textSearch_ = new Text(com, SWT.BORDER);
	    textSearch_.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
	    textSearch_.addFocusListener(new FocusAdapter() {
			public void focusGained(FocusEvent arg0) {
				textSearch_focusGained(arg0);
			}	
	    });
	    textSearch_.addKeyListener(new KeyAdapter() {
			public void keyPressed(KeyEvent arg0) {
				textSearch_keyPressed(arg0);
			}
	    });
	    
	    cmbFileType_ = new Combo(com, SWT.READ_ONLY);
		listFileType_ = new ArrayList();
	    
	    cmbFileType_.add(Messages.getString("MainFrame.Toolbar.FileType.All")); //$NON-NLS-1$
	    listFileType_.add("");
	    
	    cmbFileType_.add(Messages.getString("MainFrame.Toolbar.FileType.Doc")); //$NON-NLS-1$
	    listFileType_.add("type:" + Constants.TYPE_MSWORD);

	    cmbFileType_.add(Messages.getString("MainFrame.Toolbar.FileType.Ppt")); //$NON-NLS-1$
	    listFileType_.add("type:" + Constants.TYPE_MSPOWERPOINT);

	    cmbFileType_.add(Messages.getString("MainFrame.Toolbar.FileType.Xls")); //$NON-NLS-1$
	    listFileType_.add("type:" + Constants.TYPE_MSEXCEL);

	    cmbFileType_.add(Messages.getString("MainFrame.Toolbar.FileType.Txt")); //$NON-NLS-1$
	    listFileType_.add("type:" + Constants.TYPE_TEXT);

	    cmbFileType_.add(Messages.getString("MainFrame.Toolbar.FileType.Html")); //$NON-NLS-1$
	    listFileType_.add("type:" + Constants.TYPE_HTML);

	    cmbFileType_.add(Messages.getString("MainFrame.Toolbar.FileType.Pdf")); //$NON-NLS-1$
	    listFileType_.add("type:" + Constants.TYPE_PDF);

	    cmbFileType_.add(Messages.getString("MainFrame.Toolbar.FileType.Mail")); //$NON-NLS-1$
	    listFileType_.add("type:" + Constants.TYPE_MIME);

	    cmbFileType_.setVisibleItemCount(10);
	    cmbFileType_.select(0);
	    
		Button button1 = new Button(com, SWT.PUSH);
	    button1.setText(Messages.getString("MainFrame.Toolbar.SearchButton")); //$NON-NLS-1$
	    button1.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent arg0) {
				btnSearch_widgetSelected();
			}
	    });
	    
	    checkOrderScore_ = new Button(com, SWT.RADIO);
		checkOrderScore_.setText(Messages.getString("MainFrame.Toolbar.OrderBy.Score")); //$NON-NLS-1$
	    checkOrderScore_.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent arg0) {
				btnSearch_widgetSelected();
			}
	    });

	    checkOrderDate_ = new Button(com, SWT.RADIO);
		checkOrderDate_.setText(Messages.getString("MainFrame.Toolbar.OrderBy.Date")); //$NON-NLS-1$
		checkOrderDate_.setSelection(true);
		checkOrderDate_.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent arg0) {
				btnSearch_widgetSelected();
			}
		});
	}
	
	/**
	 * []eLXg{bNXŃL[ꂽƂɌĂ΂郁\bh
	 * 
	 * @param arg0 L[Cxg
	 */
	protected void textSearch_keyPressed(KeyEvent arg0) {
		if (arg0.keyCode == SWT.CR) {
			btnSearch_widgetSelected();
		}
	}

	/**
	 * [] eLXg{bNXtH[JX𓾂ƂɌĂ΂郁\bh
	 * 
	 * @param arg0 tH[JXCxg
	 */
	protected void textSearch_focusGained(FocusEvent arg0) {
		textSearch_.setSelection(0, textSearch_.getText().length() + 1);
	}

	/**
	 * []{^ꂽƂ̏
	 */
	private void btnSearch_widgetSelected() {
		if (textSearch_.getText().trim().length() == 0) return;
		
		String text = textSearch_.getText().trim();
		
		// t@C̎ނI΂ĂꍇAt
		if (cmbFileType_.getSelectionIndex() > 0) {
			if (text.startsWith("type:") || text.indexOf(" type:") >= 0 || text.indexOf("@type:") >= 0) {
				text = text.replaceFirst("type:[a-z|A-Z|0-9|/]+", "").trim();
			}
			
			int index = cmbFileType_.getSelectionIndex();
			text += " " + listFileType_.get(index);
			cmbFileType_.select(0);
			textSearch_.setText(text);
		}
		
		search(text);
		
		TreeItem[] children = treeRootItem_.getItems();
		
		// łɃc[ɓo^Ă΁AȂ
		if (children != null) {
			for (int i=0; i<children.length; i++) {
				TreeItem item = children[i];
				if (item.getText().equals(text))  return;
			}
		}
		
		TreeItem item = new TreeItem(treeRootItem_, SWT.NULL, 0);
		item.setText(text);
		treeSearchCondition_.setSelection(new TreeItem[]{item});
		
		while (treeRootItem_.getItemCount() > generalSettings_.getMaxHistoryCount()) {
			TreeItem treeitem = treeRootItem_.getItem( treeRootItem_.getItemCount() - 1 );
			treeitem.dispose();
		}
	}
	
	/**
	 * s郁\bh
	 * 
	 * @param text 
	 */
	private void search(String text) {
		treeFileList_.removeAll();
		textBodyFullText_.setText("");
		textBodySummary_.setText("");
		browser_.setUrl(Constants.BROWSER_BLANK_PAGE);
		bodyTextFilePath_ = "";
    	lastSearchWord_ = "";
    	currentlySelectedDocument_ = null;
		resetHeaderPane();
		
		// eLXgǂݍ݃Xbh쒆ł΁A~
    	if (textFileLoadThread_ != null && textFileLoadThread_.isAlive()) {
    		System.out.println("eLXgǂݍ݃Xbh쒆Ȃ̂ŁA~܂B");
    		
    		textFileLoadThread_.stopLoading();

    		try {
				textFileLoadThread_.join();
			} catch (InterruptedException ex) {
				ex.printStackTrace();
			}
    	}

    	Database db = new Database();

	    if (!db.open(indexSettings_.getIndexDataFolder(), Database.DBREADER | Database.DBNOLCK)){
	    	MessageBox box1 = new MessageBox(shell_, SWT.OK | SWT.ICON_ERROR);
	    	box1.setMessage(Messages.getString("MainFrame.Error.DatabaseOpening")); //$NON-NLS-1$
	    	box1.open();
	    	return;
	    }
	    
	    Cursor waitCursor = new Cursor(null, SWT.CURSOR_WAIT);
	    shell_.setCursor(waitCursor);

	    Condition cond = new Condition();
	    SearchStringParser parser = new SearchStringParser(text);
	    cond.set_phrase(parser.getPhrase());
	    
	    String[] attributes = parser.getAttributes();
	    if (attributes != null) {
	    	for (int i=0; i<attributes.length; i++) {
	    		cond.add_attr(attributes[i]);
	    	}
	    }

	    if (checkOrderDate_.getSelection()) { 
	    	cond.set_order("@mdate NUMD");
	    } else {
	    	// XRÂƂ́AIɕ⏕CfbNXgpȂƂݒ肷
	    	cond.set_auxiliary(-1);
	    }
	    
	    if (generalSettings_.isLimitFileNumber())  cond.set_max( generalSettings_.getFileNumberLimitation() );
	    if (generalSettings_.isClipFiles()) {
	    	cond.set_eclipse( generalSettings_.getEclipseLimit() );
	    }
	    
	    // s
	    Result result = db.search(cond);
	    treeFileList_.setRedraw(false);

	    for(int i = 0; i < result.doc_num(); i++){
	    	addFoundFile(db, result.get_doc_id(i), result, result.get_score(i));
	    }
	    
	    treeFileList_.setRedraw(true);

	    if (result.hint("") == result.doc_num()) {
		    statusBar_.setText(Messages.getString("MainFrame.Statusbar.Results1-1") + result.doc_num() + Messages.getString("MainFrame.Statusbar.Results1-2")); //$NON-NLS-1$ //$NON-NLS-2$
	    } else {
		    statusBar_.setText(Messages.getString("MainFrame.Statusbar.Results2-1") + result.hint("") + Messages.getString("MainFrame.Statusbar.Results2-2") + result.doc_num() + Messages.getString("MainFrame.Statusbar.Results2-3")); //$NON-NLS-1$ //$NON-NLS-3$ //$NON-NLS-4$
	    }

	    if (!db.close())
	    	System.err.println("error: " + db.err_msg(db.error()));
	    
	    // vr[yC̃nCCg\
	    if (lineStyleListener_ != null) {
		    textBodyFullText_.removeLineStyleListener(lineStyleListener_);
		    textBodySummary_.removeLineStyleListener(lineStyleListener_);
	    }
	    
    	HighlightListener listener = new HighlightListener(parser.getHighlightWordList());
    	lineStyleListener_ = listener;
    	textBodyFullText_.addLineStyleListener(listener);
    	textBodySummary_.addLineStyleListener(listener);

    	// c[o[ݒ
    	setupWordSearchToolbar(parser);

	    shell_.setCursor(null);
	    waitCursor.dispose();
	}

	/**
	 * S^uAuEU^ǔc[o[ݒ肷郁\bh
	 * 
	 * @param parser
	 */
	private void setupWordSearchToolbar(SearchStringParser parser) {
		while (toolbarSearchWord_.getItemCount() > 0) {
    		toolbarSearchWord_.getItem(0).dispose();
    	}
		
		if (toolbarSearchWordBrowser_ != null) {
	    	while (toolbarSearchWordBrowser_.getItemCount() > 0) {
	    		toolbarSearchWordBrowser_.getItem(0).dispose();
	    	}
		}
		
    	for (int i=0; i<parser.getHighlightWordList().size(); i++) {
    		String word = (String)parser.getHighlightWordList().get(i);

    		{
	    		ToolItem item = new ToolItem(toolbarSearchWord_, SWT.PUSH);
	    		item.setText(" " + word + " ");
	    		item.addSelectionListener(new SelectionAdapter() {
					public void widgetSelected(SelectionEvent arg0) {
						toolItemSearchWord_widgetSelected(arg0);
					}
	    		});
	    		
	    		new ToolItem(toolbarSearchWord_, SWT.SEPARATOR);
    		}

    		if (toolbarSearchWordBrowser_ != null) {
	    		ToolItem item = new ToolItem(toolbarSearchWordBrowser_, SWT.PUSH);
	    		item.setText(" " + word + " ");
	    		item.addSelectionListener(new SelectionAdapter() {
					public void widgetSelected(SelectionEvent arg0) {
						toolItemSearchWordBrowser_widgetSelected(arg0);
					}
	    		});
	    		
	    		new ToolItem(toolbarSearchWordBrowser_, SWT.SEPARATOR);
    		}
    	}
    	
    	lastSearchWord_ = "";
	}
	
	/**
	 * SeLXg^úuǂݍݒ~v{^ꂽƂɌĂ΂郁\bh
	 */
	protected void toolItemSearchWord_stopTextFileLoading() {
    	textBodyFullText_.setData(Constants.DATA_LOADING_FILE, null);

		// eLXgǂݍ݃Xbh쒆ł΁A~
    	if (textFileLoadThread_ != null && textFileLoadThread_.isAlive()) {
    		System.out.println("eLXgǂݍ݃Xbh쒆Ȃ̂ŁA~܂B");
    		
    		textFileLoadThread_.stopLoading();
    	}
	}

	/**
	 * Ńqbgt@Ct@Cꗗc[ɒǉ郁\bh
	 * 
	 * @param db
	 * @param id
	 * @param result
	 */
	private void addFoundFile(Database db, int id, Result result, int score) {
		Document doc = db.get_doc(id, 0);
		
		if (doc == null)  return;
		
		if (!doc.attr( Constants.ATTRIBUTE_URI ).startsWith("file:")) {
			// URI file: ȊOȂ̂ŁAꂼ̃vOCŏ
			
			//TODO IuWFNgwۂ悤ɕς
			
			TreeItem titem = hidemarumail.Util.createTreeItemFromHeDocument(
					doc, treeFileList_, score);

			if (generalSettings_.isClipFiles()) {
				int[] js = result.get_shadows( doc.id() );
				if (js != null && js.length > 0) { 
					hidemarumail.Util.addShadowItemFromHeDocument(db, js, titem);
				}
			}

			return;
		}
		
		// ȉAURIʏ file: ɂȂĂ̂ւ̏
 
		File file = null;
		
		if (doc.attr( Constants.ATTRIBUTE_REAL_PATH ) != null) {
			file = Util.convertPathToNativePlatform( doc.attr( Constants.ATTRIBUTE_REAL_PATH ) );

			if (file == null) {
				// t@Cɂ݂͑ȂƎvBDB̃pX̂܂ܕ\B
				file = new File(doc.attr( Constants.ATTRIBUTE_REAL_PATH ));
			}
		}
		
		String folder = "";
		if (file != null)  folder = file.getParent();
		
		String type = doc.attr( Constants.ATTRIBUTE_DOCUMENT_TYPE ); 
		
		String filename = "";
		if (file != null)  	filename = file.getName();
		
		if (type != null) {
			if (type.equals( Constants.TYPE_MIME )) {
				filename = formatMimeName(doc, filename);
			} else if (type.equals( Constants.TYPE_HTML)) {
				filename = formatHtmlName(doc, filename);
			}
		}
		
		TreeItem titem = new TreeItem(treeFileList_, SWT.NULL);
		String[] data = {
			filename,
			Integer.toString( score ),
			Util.convertSizeFormat( doc.attr("@size") ),
			type,
			Util.convertW3CDTFDatetimeFormat(doc.attr( Constants.ATTRIBUTE_MODIFIED_DATE )),
			folder,
		};
		titem.setText(data);
		titem.setData(Constants.DATA_DOCUMENT_ID, new Integer(doc.id()));
		titem.setData(Constants.ATTRIBUTE_URI, doc.attr( Constants.ATTRIBUTE_URI ));
		titem.setData(Constants.ATTRIBUTE_REAL_PATH, doc.attr( Constants.ATTRIBUTE_REAL_PATH ));

		
		String doc_filename = doc.attr( Constants.ATTRIBUTE_FILENAME );
		
		if (doc_filename != null && doc_filename.lastIndexOf('.') >= 0) {
			// t@CɊgq΁AɉACRݒ肷
			String ext = doc_filename.substring( doc_filename.lastIndexOf('.') );
			Image image = ImageManager.getInstance().getImage(display_, ext);
			titem.setImage(image);
		} else {
			if (type != null && type.equals( Constants.TYPE_MIME )) {
				Image image = ImageManager.getInstance().getImage(display_, ".eml");
				titem.setImage(image);
			}
		}

		if (generalSettings_.isClipFiles()) {
			int[] js = result.get_shadows( doc.id() );
			if (js != null && js.length > 0)  addShadowFiles(db, js, titem);
		}
	}

	/**
	 * [U[̐ݒɍ킹AHTMLt@ĆuOv̓eݒ肷郁\bh
	 * 
	 * @param doc H.E.hLg
	 * @param filename t@C
	 * @return uOvɕ\镶
	 */
	private String formatHtmlName(Document doc, String filename) {
		switch (generalSettings_.getHtmlNameFlag()) {
		case GeneralSettingsModel.HTML_SHOW_FILENAME:
			break;
		case GeneralSettingsModel.HTML_SHOW_TITLE:
			filename = doc.attr(Constants.ATTRIBUTE_TITLE);
			break;
		case GeneralSettingsModel.HTML_SHOW_FILENAME_TITLE:
			filename = filename + "/" + doc.attr(Constants.ATTRIBUTE_TITLE);
			break;
		case GeneralSettingsModel.HTML_SHOW_TITLE_FILENAME:
			filename = doc.attr(Constants.ATTRIBUTE_TITLE) + "/" + filename;
			break;
		}
		return filename;
	}

	/**
	 * [U[̐ݒɍ킹AMIMEt@ĆuOv̓eݒ肷郁\bh
	 * 
	 * @param doc H.E.hLg
	 * @param filename t@C
	 * @return uOvɕ\镶
	 */
	private String formatMimeName(Document doc, String filename) {
		switch (generalSettings_.getMimeNameFlag()) {
		case GeneralSettingsModel.MIME_SHOW_FILENAME:
			break;
		case GeneralSettingsModel.MIME_SHOW_SUBJECT:
			filename = doc.attr("@title");
			break;
		case GeneralSettingsModel.MIME_SHOW_FILENAME_SUBJECT:
			filename = filename + "/" + doc.attr("@title");
			break;
		case GeneralSettingsModel.MIME_SHOW_SUBJECT_FILENAME:
			filename = doc.attr("@title")+ "/" + filename;
			break;
		}
		return filename;
	}
	
	/**
	 * ގǉ郁\bh
	 *
	 * @param db Hyper Estraierf[^x[X
	 * @param js ގIDz
	 * @param parent ec[ACe
	 */
	private void addShadowFiles(Database db, int[] js, TreeItem parent) {
		for (int i=0; i<js.length; i+=2) {
			Document doc = db.get_doc(js[i], 0);
			assert doc != null : "Document data is null";

			File file = null;
			
			if (doc.attr( Constants.ATTRIBUTE_REAL_PATH ) != null) {
				file = Util.convertPathToNativePlatform( doc.attr( Constants.ATTRIBUTE_REAL_PATH ) );
				
				if (file == null) {
					file = new File(doc.attr( Constants.ATTRIBUTE_REAL_PATH ));
				}
			}
			
			String folder = "";
			
			if (file != null)  folder = file.getParent();
			
			String filename = "";
			if (file != null)  	filename = file.getName();

			String type = doc.attr( Constants.ATTRIBUTE_DOCUMENT_TYPE ); 

			if (type != null) {
				if (type.equals( Constants.TYPE_MIME )) {
					filename = formatMimeName(doc, filename);
				} else if (type.equals( Constants.TYPE_HTML )) {
					filename = formatHtmlName(doc, filename);
				}
			}

			double score = js[i+1] >= 9999 ? 1.0 : js[i+1] / 10000.0;
			String scoreStr = Double.toString( score );
			
			if (scoreStr.indexOf('.') > 0 && scoreStr.length() > scoreStr.indexOf('.') + 4) {
				scoreStr = scoreStr.substring(0, scoreStr.indexOf('.') + 4);
			}

			TreeItem titem = new TreeItem(parent, SWT.NULL);
			String[] dat = {
				filename,
				scoreStr,
				Util.convertSizeFormat( doc.attr( Constants.ATTRIBUTE_FILESIZE ) ),
				type,
				Util.convertW3CDTFDatetimeFormat(doc.attr( Constants.ATTRIBUTE_MODIFIED_DATE )),
				folder,
			};
			titem.setText(dat);
			titem.setData(Constants.DATA_DOCUMENT_ID, new Integer(doc.id()));
			titem.setData(Constants.ATTRIBUTE_URI, doc.attr( Constants.ATTRIBUTE_URI ));
			titem.setData(Constants.ATTRIBUTE_REAL_PATH, doc.attr( Constants.ATTRIBUTE_REAL_PATH ));

			
			String doc_filename = doc.attr( Constants.ATTRIBUTE_FILENAME );
			
			if (doc_filename != null && doc_filename.lastIndexOf('.') >= 0) {
				String ext = doc_filename.substring( doc_filename.lastIndexOf('.') );
				Image image = ImageManager.getInstance().getImage(display_, ext);
				titem.setImage(image);
			} else {
				if (type != null && type.equals( Constants.TYPE_MIME )) {
					Image image = ImageManager.getInstance().getImage(display_, ".eml");
					titem.setImage(image);
				}
			}
		}
	}
	
	/**
	 * {c[o[̌ꂪNbNꂽƂɌĂ΂郁\bh
	 * 
	 * @param arg0 ZNVCxg
	 */
	protected void toolItemSearchWord_widgetSelected(SelectionEvent arg0) {
		assert arg0.widget instanceof ToolItem;
		
		ToolItem item = (ToolItem)arg0.widget;
		String word = item.getText().trim().toLowerCase();
		String body = textBodyFullText_.getText().toLowerCase();
		
		Point selection = textBodyFullText_.getSelection();
		String selectionText = textBodyFullText_.getSelectionText().toLowerCase();
		
		int searchStartPos = 0;
		
		if (selectionText.equals(word)) {
			searchStartPos = selection.y;
		}
		
		int pos = body.indexOf(word, searchStartPos);
		
		if (pos < 0) {
			pos = body.indexOf(word);
		
			if (pos < 0)  return;
		}
		
		textBodyFullText_.setSelection(pos, pos + word.length());
		textBodyFullText_.setFocus();
	}

	/**
	 * t@Cꗗc[̑IύXꂽƂɌĂ΂郁\bh
	 *
	 * @param e ZNVCxg
	 */
	private void treeFileList_widgetSelected(SelectionEvent e) {
		TreeItem[] selection = treeFileList_.getSelection();
		if (selection == null || selection.length == 0 || selection.equals( lastFileTreeSelection_ ))  return;
		
		if (selection != null && lastFileTreeSelection_ != null && selection.length == lastFileTreeSelection_.length) {
			for (int i=0; i<selection.length; i++) {
				if (!selection[i].equals( lastFileTreeSelection_[i] ))  break;

				// IύXĂȂƂ́AȂ
				if (i == selection.length -1)  return;
			}
		}
		
		// eLXgǂݍ݃Xbh쒆ł΁A~
    	if (textFileLoadThread_ != null && textFileLoadThread_.isAlive()) {
    		System.out.println("eLXgǂݍ݃Xbh쒆Ȃ̂ŁA~܂B");
    		
    		textFileLoadThread_.stopLoading();

    		try {
				textFileLoadThread_.join();
			} catch (InterruptedException ex) {
				ex.printStackTrace();
			}
    	}

    	textBodySummary_.setText("");
		textBodyFullText_.setText("");
		browser_.setUrl(Constants.BROWSER_BLANK_PAGE);
		lastSearchWord_ = "";
		
	    Cursor waitCursor = new Cursor(null, SWT.CURSOR_WAIT);
	    shell_.setCursor(waitCursor);

	    // create the database object
	    Database db = new Database();

	    // open the database
	    if (!db.open(indexSettings_.getIndexDataFolder(), Database.DBREADER | Database.DBNOLCK)){
	    	MessageBox box1 = new MessageBox(shell_, SWT.OK | SWT.ICON_ERROR);
	    	box1.setMessage(Messages.getString("MainFrame.Error.DatabaseOpening")); //$NON-NLS-1$
	    	box1.open();
	    	return;
	    }
		
	    int id = ((Integer)selection[0].getData(Constants.DATA_DOCUMENT_ID)).intValue();
	    currentlySelectedDocument_ = db.get_doc(id, 0);
	    
	    // fobOp
//	    System.out.println("@uri: " + doc.attr("@uri"));

	    String documentType = "";
	    
	    if (currentlySelectedDocument_.attr(Constants.ATTRIBUTE_DOCUMENT_TYPE) != null) {
	    	documentType = currentlySelectedDocument_.attr(Constants.ATTRIBUTE_DOCUMENT_TYPE);
	    }

	    // hLg̃^CvɉāAK؂ȃwb_ݒ肷
	    if (documentType.equals( Constants.TYPE_MIME )) {
	    	createAndSetInfoToHeaderForMime();

	    } else if (documentType.equals(Constants.TYPE_HTML)) {
	    	createAndSetInfoToHeaderForHtml();
	    	
	    } else {
	    	createAndSetInfoToHeaderForFile();
	    }

	    bodyTextFilePath_ = currentlySelectedDocument_.attr( Constants.ATTRIBUTE_REAL_PATH );
	    bodyTextFileType_ = currentlySelectedDocument_.attr( Constants.ATTRIBUTE_DOCUMENT_TYPE );
	    
	    if (bodyTextFileType_.equals( Constants.TYPE_TEXT )
	    		|| bodyTextFileType_.equals( Constants.TYPE_MIME )
	    		|| bodyTextFileType_.equals( Constants.TYPE_MSWORD )
	    		|| bodyTextFileType_.equals( Constants.TYPE_MSEXCEL )
	    		|| bodyTextFileType_.equals( Constants.TYPE_MSPOWERPOINT )
	    		|| bodyTextFileType_.equals( Constants.TYPE_PDF )) {
	    	// ̃t@ĆA[S]^u͕ʓr
	    	
	    	if (tabFolderBodyPane_.getSelectionIndex() == 1) {
	    		tabFolderBodyPane_widgetSelected(null);
	    	}
	    } else {
	    	// ȊOBHyer EstraierS擾B
		    StringBuffer buf = new StringBuffer();
			Iterator it = currentlySelectedDocument_.texts().iterator();
			while (it.hasNext()) {
				buf.append((String)it.next());
				buf.append("\r\n");
			}
			
			textBodyFullText_.setText(buf.toString());
	    }
	    
	    // "Tv"𐶐
	    {
	    	String summary = MainProcedure.getSummaryText(currentlySelectedDocument_, 
	    			textSearch_.getText(), spinnerSummaryCount_.getSelection());
			textBodySummary_.setText(summary);
	    }
		
	    // uuEUv^uIĂƂ́AuEUR|[lgɓǂݍ܂
    	if (tabFolderBodyPane_.getSelectionIndex() == 2) {
			if (currentlySelectedDocument_.attr("@uri").startsWith("file")) {
				try {
					browser_.setUrl(Util.convertPathToNativePlatform( bodyTextFilePath_ ).toURL().toString());
				} catch (MalformedURLException e1) {
					e1.printStackTrace();
				}
			}
    	} 
    	
	    if (!db.close())
	    	System.err.println("error: " + db.err_msg(db.error()));

    	shell_.setCursor(null);
	    waitCursor.dispose();
		lastFileTreeSelection_ = selection;
	}

	private void createAndSetInfoToHeaderForFile() {
		Control[] children = cmpFileInfo.getChildren();
		
		if (children != null && children.length > 0) {
			for (int i=0; i<children.length; i++) {
				children[i].dispose();
			}
		}
		
        GridData gridDataFillHorizontal = new GridData(GridData.FILL_HORIZONTAL);
    	
    	Composite cmpLine1 = new Composite(cmpFileInfo, SWT.NULL);
		GridLayout gridLayout2 = new GridLayout(4, false);
    	gridLayout2.marginHeight = 0;
    	gridLayout2.marginTop = 0;
    	gridLayout2.marginBottom = 0;
    	cmpLine1.setLayout(gridLayout2);
    	cmpLine1.setLayoutData(gridDataFillHorizontal);
    	
    	Label label1 = new Label(cmpLine1, SWT.NULL);
    	label1.setText(Messages.getString("MainFrame.Header.File.Name")); //$NON-NLS-1$
    	Font font = label1.getFont();
    	FontData[] fontData = font.getFontData();
    	for (int i=0; i<fontData.length; i++) {
    		fontData[i].setStyle(SWT.BOLD);
    	}
    	
    	Font boldFont = new Font(display_, fontData);
    	label1.setFont(boldFont);
    	
    	Label lblTitle = new Label(cmpLine1, SWT.NULL);
    	
    	String path = currentlySelectedDocument_.attr(Constants.ATTRIBUTE_REAL_PATH);
    	
    	if (path != null)  lblTitle.setText(Util.convertPathToNativePlatform( path ).getAbsolutePath());
		
		cmpFileInfo.getParent().layout(true, true);
	}

	/**
	 * HTML`̃hLgɂāAwb_̈𐶐AZbg郁\bh
	 * 
	 */
	private void createAndSetInfoToHeaderForHtml() {
		Control[] children = cmpFileInfo.getChildren();
		
		if (children != null && children.length > 0) {
			for (int i=0; i<children.length; i++) {
				children[i].dispose();
			}
		}
		
        GridData gridDataFillHorizontal = new GridData(GridData.FILL_HORIZONTAL);
    	
    	Composite cmpLine1 = new Composite(cmpFileInfo, SWT.NULL);
		GridLayout gridLayout2 = new GridLayout(4, false);
    	gridLayout2.marginHeight = 0;
    	gridLayout2.marginTop = 0;
    	gridLayout2.marginBottom = 0;
    	cmpLine1.setLayout(gridLayout2);
    	cmpLine1.setLayoutData(gridDataFillHorizontal);
    	
    	Label label1 = new Label(cmpLine1, SWT.NULL);
    	label1.setText(Messages.getString("MainFrame.Header.Html.Title")); //$NON-NLS-1$
    	Font font = label1.getFont();
    	FontData[] fontData = font.getFontData();
    	for (int i=0; i<fontData.length; i++) {
    		fontData[i].setStyle(SWT.BOLD);
    	}
    	
    	Font boldFont = new Font(display_, fontData);
    	label1.setFont(boldFont);
    	
    	Label lblTitle = new Label(cmpLine1, SWT.NULL);
    	
    	String title = currentlySelectedDocument_.attr(Constants.ATTRIBUTE_TITLE);
    	
    	if (title != null)  lblTitle.setText(title);
		
		cmpFileInfo.getParent().layout(true, true);
	}

	/**
	 * t@Cwb_郁\bh
	 */
	private void resetHeaderPane() {
		Control[] children = cmpFileInfo.getChildren();
		
		if (children != null && children.length > 0) {
			for (int i=0; i<children.length; i++) {
				children[i].dispose();
			}
		}
		
    	new Label(cmpFileInfo, SWT.NULL);
		cmpFileInfo.getParent().layout(true, true);
	}
	
	/**
	 * MIME`̃hLgɂāAwb_̈𐶐AZbg郁\bh
	 * 
	 */
	private void createAndSetInfoToHeaderForMime() {
		Control[] children = cmpFileInfo.getChildren();
		
		if (children != null && children.length > 0) {
			for (int i=0; i<children.length; i++) {
				children[i].dispose();
			}
		}
		
        GridData gridDataFillHorizontal = new GridData(GridData.FILL_HORIZONTAL);
    	
    	Composite cmpLine1 = new Composite(cmpFileInfo, SWT.NULL);
		GridLayout gridLayout2 = new GridLayout(4, false);
    	gridLayout2.marginHeight = 0;
    	gridLayout2.marginTop = 0;
    	gridLayout2.marginBottom = 0;
    	cmpLine1.setLayout(gridLayout2);
    	cmpLine1.setLayoutData(gridDataFillHorizontal);
    	
    	Label label1 = new Label(cmpLine1, SWT.NULL);
    	label1.setText(Messages.getString("MainFrame.Header.Mime.From")); //$NON-NLS-1$
    	Font font = label1.getFont();
    	FontData[] fontData = font.getFontData();
    	for (int i=0; i<fontData.length; i++) {
    		fontData[i].setStyle(SWT.BOLD);
    	}
    	
    	Font boldFont = new Font(display_, fontData);
    	label1.setFont(boldFont);
    	
    	Label lblFrom = new Label(cmpLine1, SWT.NULL);
		Label label3 = new Label(cmpLine1, SWT.NULL);
    	label3.setText(Messages.getString("MainFrame.Header.Mime.To")); //$NON-NLS-1$
    	label3.setFont(boldFont);

    	Label lblTo = new Label(cmpLine1, SWT.NULL);

    	Composite cmpLine2 = new Composite(cmpFileInfo, SWT.NULL);
    	GridLayout gridLayout3 = new GridLayout(2, false);
    	cmpLine2.setLayout(gridLayout3);
    	gridLayout3.marginHeight = 0;
    	gridLayout3.marginTop = 0;
    	gridLayout3.marginBottom = 0;
    	cmpLine2.setLayoutData(gridDataFillHorizontal);

    	Label label5 = new Label(cmpLine2, SWT.NULL);
    	label5.setText(Messages.getString("MainFrame.Header.Mime.Subject")); //$NON-NLS-1$
    	label5.setFont(boldFont);

    	Label lblSubject = new Label(cmpLine2, SWT.NULL);
    	
    	lblFrom.setText( currentlySelectedDocument_.attr("@author") == null ? 
    			"" : currentlySelectedDocument_.attr("@author") );
		lblTo.setText( currentlySelectedDocument_.attr("to") == null ? 
				"" : currentlySelectedDocument_.attr("to") );
		lblSubject.setText( currentlySelectedDocument_.attr("@title") == null ? 
				"" : currentlySelectedDocument_.attr("@title") );
		
		cmpFileInfo.getParent().layout(true, true);
	}

	/**
	 * uEU^ǔc[o[NbNꂽƂ̏
	 * 
	 * @param arg0
	 */
	protected void toolItemSearchWordBrowser_widgetSelected(SelectionEvent arg0) {
		ToolItem item = (ToolItem)arg0.widget;
		String word = item.getText().trim().toLowerCase();
		
		assert word != null && word.length() > 0;
		
		if (lastSearchWord_ == null || lastSearchWord_.length() == 0 || !lastSearchWord_.equals( word )) {
			
			if (lastSearchWord_ == null || lastSearchWord_.length() > 0) {
				// OƈقȂ̌Ȃ̂ŁAuEǓ݂̑I
				String script = "document.selection.empty();";
				browser_.execute(script);
			}
		}
		
		String script = 
			"var selRange = document.selection.createRange();" +
			"var objRange = document.body.createTextRange();" +
			" " +	
			"if (selRange.text.length > 0) {" +
			"    objRange.moveToBookmark( selRange.getBookmark() );" +
			"    objRange.collapse(false);" +
			"}" +
			"" +
			"if (objRange.findText('" + word +"', 1)) {" +
			"    objRange.select();" +
			"    objRange.scrollIntoView();" +
			"} else {" +
			"    objRange = document.body.createTextRange();" +
			"    if (objRange.findText('" + word +"', 1)) {" +
			"        objRange.select();" +
			"        objRange.scrollIntoView();" +
			"    }" +
			"}";

		browser_.execute(script);
		browser_.setFocus();
		lastSearchWord_ = word;
	}

	/**
	 * vpeBt@CÕEBhËʒuATCYǂݏoZbg֐
	 * 
	 * @return  true, s false Ԃ
	 */
	private boolean loadProperties() {
		String filepath = Util.getPropertyFilePath();

		// t@C݂Aǂݏo邱ƂmF
		if (!(new File(filepath).canRead())) {
			return false;
		}

		Properties  prop;
		try{
			FileInputStream in = new FileInputStream(filepath);
			prop = new Properties();
			prop.load(in);

			// ǂݍ݁Zbg
			shell_.setBounds(
				Integer.parseInt(prop.getProperty("X")),
				Integer.parseInt(prop.getProperty("Y")),
				Integer.parseInt(prop.getProperty("Width")),
				Integer.parseInt(prop.getProperty("Height")) );
			
			if (prop.getProperty("checkOrderDate_Selection") != null) {
				boolean orderDate = Boolean.valueOf( prop.getProperty("checkOrderDate_Selection") ).booleanValue();
				
				if (orderDate) {
					checkOrderScore_.setSelection(false);
					checkOrderDate_.setSelection(true);
				} else {
					checkOrderScore_.setSelection(true);
					checkOrderDate_.setSelection(false);
				}
			}
			
			if (prop.getProperty("shell_Maximized") != null) {
				boolean b = Boolean.valueOf( prop.getProperty("shell_Maximized") ).booleanValue();
				if (b) {
					shell_.setMaximized(true);
				}
			}

			{
				int[] hsweights = new int[2];
				for (int i=0; i<hsweights.length; i++) {
					hsweights[i] = Integer.parseInt(prop.getProperty("horizontalSash_weight" + i));
				}
				
				horizontalSash_.setWeights(hsweights);
			}

			{
				int[] vsweights = new int[2];
				for (int i=0; i<vsweights.length; i++) {
					vsweights[i] = Integer.parseInt(prop.getProperty("verticalSash_weight" + i));
				}
				
				verticalSash_.setWeights(vsweights);
			}

			{
				TreeColumn[] cols = treeFileList_.getColumns();
				for (int i=0; i<cols.length; i++) {
					if (prop.getProperty("column_width" + i) != null) {
						cols[i].setWidth(Integer.parseInt(prop.getProperty("column_width" + i)));
					}
				}
			}
			
			for (int i=0; ; i++) {
				String str = prop.getProperty("TreeItem" + i);
				if (str == null)  break;
					
				TreeItem item = new TreeItem(treeRootItem_, SWT.NULL);
				item.setText(str);
			}
			
			if (prop.getProperty("spinnerSummaryCount_Selection") != null) {
				spinnerSummaryCount_.setSelection( Integer.parseInt( prop.getProperty("spinnerSummaryCount_Selection") ) );
			}
			
			indexSettings_.load(prop);
			generalSettings_.load(prop);
			advancedIndexSettingModel_.load(prop);
			
			textBodyFullText_.setFont(new Font(display_, generalSettings_.getFontDataBody()));
			textBodySummary_.setFont(new Font(display_, generalSettings_.getFontDataBody()));

			return true;
		} catch (Exception er) {
		}

		return false;
	}
}

