package desktophe;

import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;


/**
 * ͕Hyper Estraieř`ɕϊNX
 * 
 * @author kohno
 */
public class SearchStringParser {
	/** ͕ */
	private String inputString_;
	
	/** t[Y */
	private String searchPhrase_;
	
	/** 񃊃Xg */
	private List attributeList_;
	
	/** nCCgׂ̃Xg */
	private List highlightWordList_;
	
	
	/**
	 * RXgN^
	 * 
	 * @param str ͕
	 */
	public SearchStringParser(String str) {
		inputString_ = str;
		attributeList_ = new ArrayList();
		highlightWordList_ = new ArrayList();
		
		parse();
	}
	
	/**
	 * ͕Hyper Estraier`ɕϊ郁\bh
	 */
	private void parse() {
		StringBuffer buffer = new StringBuffer();
		String tempstr = inputString_;
		
		// t[Yw肳ꂽ
		{
			Pattern pattern = Pattern.compile("([^ @]+:\\\"[^\\\"]*\\\")");
			Matcher matcher = pattern.matcher(tempstr);
			
			while (matcher.find()) {
				attributeList_.add( matcher.group(1) );
				tempstr = matcher.replaceFirst("");
				matcher = pattern.matcher(tempstr);
			}
		}
		
		int pos = 0;

		while (true) {
			pos = tempstr.indexOf('"');
			if (pos < 0) { 
				if (tempstr.length() > 0)  processString(tempstr, buffer);
				break;
			}
			
			if (pos >= 1) {
				String head = tempstr.substring(0, pos);
				processString(head, buffer);
			}
			
			tempstr = tempstr.substring(pos + 1);
			pos = tempstr.indexOf('"');
			
			if (pos < 0) {
				if ( buffer.length() > 0 )  buffer.append(" AND ");
				
				buffer.append(tempstr);
				break;
			} else {
				String phrase = tempstr.substring(0, pos);
				if ( buffer.length() > 0 )  buffer.append(" AND ");
				
				buffer.append(phrase);
				
				tempstr = tempstr.substring(pos + 1);
			}
		}

		searchPhrase_ = buffer.toString();
	}
	
	/**
	 * Hyper Estraieřt[YԂ\bh
	 * 
	 * @return Hyper Estraieřt[Y
	 */
	public String getPhrase() {
		if (searchPhrase_ == null || searchPhrase_.length() == 0)  return "[UVSET]";
		
		return searchPhrase_;
	}

	/**
	 * Hyper Estraier`ɕϊ郁\bh
	 * 
	 * @param str
	 * @param buffer
	 */
	private void processString(String str, StringBuffer buffer) {
		str = str.trim();

		String[] strs = str.split("[ |@]+");
		
		for (int i=0; i<strs.length; i++) {
			String onestr = strs[i];
			if (onestr.indexOf(':') >= 0) {
				// xw肠
				attributeList_.add(onestr);
			} else {
				// xwȂ
				
				if (onestr.equals("OR")) {
					// OR ͉Zq
					buffer.append(" OR ");
					continue;
				}

				boolean notSearch = false;
				
				if ( buffer.length() > 0 && !buffer.toString().endsWith(" OR ") ) {
					if (onestr.substring(0, 1).equals("-")) {
						buffer.append(" ANDNOT ");
						onestr = onestr.substring(1);
						notSearch = true;
					} else {
						buffer.append(" AND ");
					}
				}
				
				// vAv
				if (onestr.length() >= 2 && onestr.endsWith("*")) {
					buffer.append("[BW] ");
					onestr = onestr.substring(0, onestr.length() - 1);
				} else if (onestr.length() >= 2 && onestr.startsWith("*")) {
					buffer.append("[EW] ");
					onestr = onestr.substring(1, onestr.length());
				}
				
				buffer.append(onestr);

				if (!notSearch) {
					highlightWordList_.add(onestr);
				}
			}
		}
	}
	
	/**
	 * ̔zԂ\bh
	 * 
	 * @return ̔zBw肪Ȃꍇnull
	 */
	public String[] getAttributes() {
		if (attributeList_.size() == 0)  return null;
		
		String[] ary = new String[attributeList_.size()];
		
		for (int i=0; i<attributeList_.size(); i++) {
			String str = (String)attributeList_.get(i);
			int pos = str.indexOf(':');
			
			assert pos >= 0;
			
			String label = str.substring(0, pos);
			String val = str.substring(pos + 1);
			
			if ("age".equals(label)) {
				ary[i] = convertAge(val);
			} else 	if ("type".equals(label)) {
				ary[i] = "@type STREQ " + val;
			} else if ("datefrom".equals(label)) {
				ary[i] = "@mdate NUMGE " + convertDateString(val, false);
			} else if ("dateto".equals(label)) {
				ary[i] = "@mdate NUMLE " + convertDateString(val, true);
			} else if ("under".equals(label)) {
				if (val.length() >= 3 && val.charAt(0) == '"' && val.charAt( val.length() - 1 ) == '"') {
					val = val.substring(1, val.length() - 1);
				}

				// '`'ȂǂHyper Estraierł́AShift_JISŋL^Ă̂ŁAϊ
				byte[] bytes = val.getBytes();
				try {
					val = new String(bytes, "Shift_JIS");
				} catch (UnsupportedEncodingException e) {
				}
				
				ary[i] = "_lreal ISTRBW " + val;
			} else {
				ary[i] = convertAttributeName(label) + " ISTRINC " + val;
			}
		}
		
		return ary;
	}

	/**
	 * t̕AUNIXǏoߕb̕ɕϊĕԂ\bh
	 * Lȓ͕́Ayyyy/mm/ddAyy/mm/ddAmm/ddAdd̂ꂩB
	 * @param val ͕
	 * @return ϊ̕
	 */
	private String convertDateString(String val, boolean isTimeEndOfDay) {
		String[] date = val.split("/");
		
		Calendar cal = Calendar.getInstance();
		
		if (isTimeEndOfDay) {
			cal.set(Calendar.HOUR, 23);
			cal.set(Calendar.MINUTE, 59);
			cal.set(Calendar.SECOND, 59);
		} else {
			cal.set(Calendar.HOUR, 0);
			cal.set(Calendar.MINUTE, 0);
			cal.set(Calendar.SECOND, 0);
		}

		try {
			if (date.length == 1) {
				cal.set(Calendar.DAY_OF_MONTH, Integer.valueOf(date[0]).intValue());
			} else if (date.length == 2) {
				cal.set(Calendar.MONTH, Integer.valueOf(date[0]).intValue() - 1);
				cal.set(Calendar.DAY_OF_MONTH, Integer.valueOf(date[1]).intValue());
			} else if (date.length == 3) {
				int year = Integer.valueOf(date[0]).intValue();
				
				if (year <= 30)  year += 2000;
				
				cal.set(Calendar.YEAR, year);
				cal.set(Calendar.MONTH, Integer.valueOf(date[1]).intValue() - 1);
				cal.set(Calendar.DAY_OF_MONTH, Integer.valueOf(date[2]).intValue());
			}
		} catch (NumberFormatException ex) {
			// just ignore
		}
		
		long time = cal.getTimeInMillis() / 1000;
		return Long.toString(time);
	}
	
	/**
	 * ύXt͈͂ɂĂ̌AHyper Estraier`ɕϊ郁\bh
	 * 
	 * @param val ͂ꂽ
	 * @return Hyper Estraier`̌
	 */
	private String convertAge(String val) {
		Calendar cal = Calendar.getInstance();
		cal.set(Calendar.HOUR, 0);
		cal.set(Calendar.MINUTE, 0);
		cal.set(Calendar.SECOND, 0);

		Pattern patternDay = Pattern.compile("([0-9]+)days?");
		Pattern patternMonth = Pattern.compile("([0-9]+)months?");
		Pattern patternYear = Pattern.compile("([0-9]+)years?");
		
		Matcher matcher = patternDay.matcher(val);
		if (matcher.matches()) {
			int n = Integer.parseInt( matcher.group(1) );
			cal.add(Calendar.DAY_OF_MONTH, n * -1);
		} else {
			matcher = patternMonth.matcher(val);
			if (matcher.matches()) {
				int n = Integer.parseInt( matcher.group(1) );
				cal.add(Calendar.MONTH, (n + 1) * -1);
			} else {
				matcher = patternYear.matcher(val);
				if (matcher.matches()) {
					int n = Integer.parseInt( matcher.group(1) );
					cal.add(Calendar.YEAR, (n + 1) * -1);
				}
			}
		}
		
		long time = cal.getTimeInMillis() / 1000;
		String timestr = Long.toString(time);
		
		return "@mdate NUMGE " + timestr;
	}
	
	/**
	 * ́AxɑΉHyper EstraieȓԂ\bh
	 * 
	 * @param label x
	 * @return Hyper Estraieȓ
	 */
	private String convertAttributeName(String label) {
		if (label.equals("name")) {
			return "_lfile";
		} else if (label.equals("path")) {
			return "_lreal";
		} else if (label.equals("type")) {
			return "@type";
		} else if (label.equals("from")) {
			return "from";
		} else if (label.equals("to")) {
			return "to";
		}
		
		return "";
	}
	
	/**
	 * nCCgׂ̃XgԂ\bh
	 * 
	 * @return nCCgׂ̃Xg
	 */
	public List getHighlightWordList() {
		if (highlightWordList_.size() == 0)  return new ArrayList();
		
		return highlightWordList_;
	}
}
