package desktophe;

import java.io.File;
import java.io.UnsupportedEncodingException;
import java.text.NumberFormat;
import java.util.regex.Pattern;

import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.widgets.Shell;

/**
 * ėp[eBeBNX
 * 
 * @author kohno
 */
public class Util {
	/** vpeBt@C */
	private static final String PROPERTY_FILE 	= "DesktopHE.properties";
	
	static {
	    System.loadLibrary("Util");
	}
	
	/**
	 * nꂽEBhEʂ̒ɔzu郁\bh
	 * 
	 * @param shell zuΏۂ̃EBhE
	 */
    static public void setShellCenter(Shell shell) {
    	Rectangle displaySize = shell.getDisplay().getBounds();
    	Rectangle shellSize = shell.getBounds();
    	
    	shell.setLocation((displaySize.width - shellSize.width) / 2, 
    			(displaySize.height - shellSize.height) / 2);
    }

	/**
	 * 󂯎ACalendarɕϊĕԂ\bh
	 * @param str
	 * @return
	 */
	private static String convertRFC822DatetimeFormat(String str) {
		int cpos = str.indexOf(',');
		if (cpos != -1) {
			str = str.substring(cpos + 1).trim();
		}
		
		Pattern pattern = Pattern.compile(" ");
		String[] strs = pattern.split(str.trim());
		
		String y, m, d, h, s;
		
		// uNvA2̏ꍇ悤Ȃ̂ŁA2Ȃ瓪"20"t
		if (strs[2].length() == 2)  strs[2] = "20" + strs[2];
		
		y = strs[2];
		m = convertMonth(strs[1]);
		d = strs[0];
		
		pattern = Pattern.compile(":");
		String[] strs2 = pattern.split(strs[3]);
		
		h = strs2[0];
		s = strs2[1];
		
		return y + "/" + m + "/" + d + " " + h + ":" + s;
	}

	/**
	 * 󂯎ɑΉuv̐lԂ\bh
	 * @param s uv̕
	 * @return uv̐l
	 */
	private static String convertMonth(String s) {
		if (s.equals("Jan")) {
			return "01";
		}
		else if (s.equals("Feb")) {
			return "02";
		}
		else if (s.equals("Mar")) {
			return "03";
		}
		else if (s.equals("Apr")) {
			return "04";
		}
		else if (s.equals("May")) {
			return "05";
		}
		else if (s.equals("Jun")) {
			return "06";
		}
		else if (s.equals("Jul")) {
			return "07";
		}
		else if (s.equals("Aug")) {
			return "08";
		}
		else if (s.equals("Sep")) {
			return "09";
		}
		else if (s.equals("Oct")) {
			return "10";
		}
		else if (s.equals("Nov")) {
			return "11";
		}
		else if (s.equals("Dec")) {
			return "12";
		}
	
		throw new StringIndexOutOfBoundsException();
	}

	/**
	 * Hyper Estraier̓t`AGNXv[̏ɕϊ郁\bh
	 * 
	 * @param str ϊ
	 * @return ϊ㕶
	 */
	static public String convertW3CDTFDatetimeFormat(String str) {
		if (str == null || str.length() == 0)  return "";
		if (str.indexOf('T') < 0)  return Util.convertRFC822DatetimeFormat(str);
		
		String date = str.substring(0, str.indexOf('T'));
		String[] dateAry = date.split("-");
		
		if (dateAry == null || dateAry.length < 3)  return Util.convertRFC822DatetimeFormat(str);
		
		String time = str.substring(str.indexOf('T') + 1);
		String[] timeAry = time.split(":");
		
		if (timeAry == null || timeAry.length < 2)  return Util.convertRFC822DatetimeFormat(str);
		
		return dateAry[0] + "/" + dateAry[1] + "/" + dateAry[2] + " " + timeAry[0] + ":" + timeAry[1];
	}

	/**
	 * vpeBt@C̃pXԂ\bh
	 * 
	 * @return vpeBt@C̃pX
	 */
	public static String getPropertyFilePath() {
		String filepath = System.getProperty("user.home");
		filepath += File.separator + "Application Data" + File.separator + "DesktopHE" 
			+ File.separator + Util.PROPERTY_FILE;
	
		return filepath;
	}

	/**
	 * ݒt@Ci[tH_̃pX𕶎ŕԂ\bh.
	 * Xy[X܂ޏꍇ́A[ " łĕԂB
	 * 
	 * @return
	 */
	public static String getSettingDataFolder() {
		String filepath = System.getProperty("user.home");
		filepath += File.separator + "Application Data" + File.separator + "DesktopHE";

		if (filepath.indexOf(' ') >= 0) {
			filepath = "\"" + filepath + "\"";
		}
		
		return filepath;
	}
	
	public static native boolean isIndexing();
	
	public static native void showContextMenu(String filepath);
	
	public static native String getJavaExePath();
	

	/**
	 * Hyper Estraier̃t@CpX́AWindows-31Jł͂ȂShift_JISɂȂĂ悤Ȃ̂ŁA
	 * u`vȂǂ̕R[hقȂBϊ郁\bh
	 * 
	 * @param path
	 * @return
	 */
	public static File convertPathToNativePlatform(String path) {
		assert path != null;
		
		File file = new File(path);
		
    	try {
    		if (path.equals(new String( path.getBytes("Shift_JIS") ))) {
				return file;
			}

			if (!file.exists()) {
	    		file = new File(new String( path.getBytes("Shift_JIS") ));
			}

			if (!file.exists()) {
				byte[] bytes = path.getBytes();
				file = new File(new String(bytes, "JISAutoDetect"));
				
				if (!file.exists()) {
		    		String shiftJISstring = new String(path.getBytes("Shift_JIS")); 
		    		
		    		while (true) {
		    			int qindex = shiftJISstring.indexOf("?");
		    			
		    			if (qindex < 0)  break;
		    		
		    			char[] buf = new char[1];
		    			buf[0] = path.charAt(qindex);
		    			shiftJISstring = shiftJISstring.replaceFirst("\\?", new String(buf));
		    		}

		    		file = new File(shiftJISstring);
					
					if (!file.exists()) {
						return null;
					}
				}
			}
		} catch (UnsupportedEncodingException e) {
			e.printStackTrace();
		}
		
		return file;
	}
	
	/**
	 * Hyper Estraier̃TCYAGNXv[̏ɕϊ郁\bh
	 * 
	 * @param str ϊ
	 * @return ϊ㕶
	 */
	static public String convertSizeFormat(String str) {
		if (str == null)  return "";
		if (str.length() <= 3)  return "1 KB";
		
		String num = str.substring(0, str.length() - 3);
		NumberFormat formatter = NumberFormat.getNumberInstance();
		return formatter.format(Long.parseLong(num)) + " KB";
	}

	public static String replaceString(String str, String n1, String n2) {
        if (str == null)  return "";
        
        String tmp = str;
        StringBuffer sb = new StringBuffer();
        int itmp = tmp.indexOf(n1); 

        while (itmp > -1) {           
            sb.append(tmp.substring(0,itmp));
            sb.append(n2);
            tmp = tmp.substring(itmp+n1.length());
            itmp = tmp.indexOf(n1);  
        }
        
        sb.append(tmp);
        return sb.toString();
    }
}
