package desktophe.dialog;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;

import desktophe.Messages;
import desktophe.Util;

/**
 * o[W_CAO
 * 
 * @author kohno
 */
public class AboutDialog extends Dialog {
    /** _CAO{ */
    private Shell shell_;

    /**
     * RXgN^
     * 
     * @param parent e
     */
	public AboutDialog(Shell parent) {
		super(parent, SWT.APPLICATION_MODAL);
		
        GridData gridDataAlignFill = new GridData(GridData.HORIZONTAL_ALIGN_FILL);
		GridData gridDataAlignEnd = new GridData(GridData.HORIZONTAL_ALIGN_END);
		GridData gridDataFillBoth = new GridData(GridData.FILL_BOTH);

        shell_ = new Shell(parent, SWT.DIALOG_TRIM | SWT.RESIZE | SWT.APPLICATION_MODAL);
        
        GridLayout layout = new GridLayout(1, false);
        layout.marginHeight = 10;
        layout.verticalSpacing = 10;
        layout.marginWidth = 20;
        shell_.setLayout(layout);
        shell_.setLayoutData(gridDataFillBoth);
        shell_.setText(Messages.getString("AboutDialog.Title")); //$NON-NLS-1$

        Composite body = new Composite(shell_, SWT.NONE);
	    GridLayout glayout = new GridLayout(2, false);
	    body.setLayout(glayout);
	    
        body.setLayoutData(gridDataFillBoth);
 
        Label l = new Label(shell_, SWT.NULL);
        l.setText("DesktopHE Ver 1.8.1");
        
        Label l2 = new Label(shell_, SWT.NULL);
        l2.setText("Copyright (C) 2005-2010 S.kohno");
    
        Label l3 = new Label(shell_, SWT.NULL);
        l3.setText("URL: http://freemind.s57.xrea.com/");

        Label line = new Label(shell_, SWT.SEPARATOR | SWT.HORIZONTAL);
        line.setLayoutData(gridDataAlignFill);
        
        {
            Label tl = new Label(shell_, SWT.NULL);
            tl.setText(Messages.getString("AboutDialog.Desc1")); //$NON-NLS-1$
        }
        {
            Label tl = new Label(shell_, SWT.NULL);
            tl.setText(Messages.getString("AboutDialog.Desc2")); //$NON-NLS-1$
        }
        {
            Label tl = new Label(shell_, SWT.NULL);
            tl.setText(Messages.getString("AboutDialog.Desc3")); //$NON-NLS-1$
        }
        {
            Label tl = new Label(shell_, SWT.NULL);
            tl.setText("zlib (C) Jean-loup Gailly");
        }
        {
            Label tl = new Label(shell_, SWT.NULL);
            tl.setText("iconv (C) Ulrich Drepper");
        }
        {
            Label tl = new Label(shell_, SWT.NULL);
            tl.setText("regex (C) Henry Spencer");
        }
        {
            Label tl = new Label(shell_, SWT.NULL);
            tl.setText("Pthreads for Win32 (C) Ben Elliston");
        }
        {
            Label tl = new Label(shell_, SWT.NULL);
            tl.setText("xdoc2txt (C) hishida");
        }

        Button btnOk = new Button(shell_, SWT.PUSH);
        btnOk.setText(" OK ");
        btnOk.setLayoutData(gridDataAlignEnd);
        btnOk.addSelectionListener(new SelectionListener() {
			public void widgetSelected(SelectionEvent arg0) {
				shell_.dispose();
			}
			public void widgetDefaultSelected(SelectionEvent arg0) {
			}
        });

        shell_.pack();
        Util.setShellCenter(shell_);
	}
	
	/**
	 * _CAO\郁\bh
	 */
	public void open() {
		shell_.open();
	}
}
