package desktophe.dialog;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import desktophe.Messages;
import desktophe.Util;
import desktophe.model.AdvancedIndexSettingModel;

/**
 * ㋉ҌCfbNXݒ_CAO
 * 
 * @author kohno
 */
public class AdvancedIndexSettingDialog extends Dialog {
    public static final int HORIZONTAL_SPACING = 3;
    public static final int MARGIN_WIDTH = 0;
    public static final int MARGIN_HEIGHT = 2;

    /** _CAO{ */
    private Shell shell_;

    /** OK{^ */
    private Button btnOk_;
    
    /** LZ{^ */
    private Button btnCancel_;
    
	/** _CAOƂɕԂ߂́AݒeێCX^X */
	AdvancedIndexSettingModel returnValueGeneralSettings_ = null;

	private Text txtIndexCommand_;
	private Text txtIndexOfficeFileCommand_;
	private Text txtPurgeCommand_;
	private Text txtExtractKeywordsCommand_;
	private Text txtOptimizeCommand_;

    
	/**
	 * RXgN^
	 * 
	 * @param parent
	 * @param setting
	 */
	public AdvancedIndexSettingDialog(Shell parent, AdvancedIndexSettingModel setting) {
    	super(parent, SWT.APPLICATION_MODAL);
    	
    	assert setting != null;

        shell_ = new Shell(parent, SWT.DIALOG_TRIM | SWT.RESIZE | SWT.APPLICATION_MODAL);
        
        createComponents(shell_, setting);
        shell_.setSize(570, 390);
        Util.setShellCenter(shell_);
	}

    /**
     * _CAÕR|[lg𐶐郁\bh
     * 
     * @param shell _CAOShell
     */
	private void createComponents(Shell shell, AdvancedIndexSettingModel setting) {
    	assert setting != null;

    	GridData gridDataFillBoth = new GridData(GridData.FILL_BOTH);				// AƂATCYgݒ
        GridData gridDataFillHorizontal = new GridData(GridData.FILL_HORIZONTAL);	// ɁATCYgݒ

        GridLayout layout = new GridLayout(1, false);
        layout.marginWidth = 10;
        shell.setLayout(layout);
        shell.setLayoutData(gridDataFillHorizontal);
        shell.setText(Messages.getString("AdvancedIndexSettingDialog.Title")); //$NON-NLS-1$
        
        {
	        Composite comp = createLeftAlignmentComposite();
	        Label l = new Label(comp, SWT.NULL);
	        l.setText(Messages.getString("AdvancedIndexSettingDialog.NormalIndexCommand")); //$NON-NLS-1$
        }

        {
	        Composite comp = createLeftAlignmentComposite();
	        
	        txtIndexCommand_ = new Text(comp, SWT.BORDER);
			txtIndexCommand_.setLayoutData(gridDataFillHorizontal);
	        txtIndexCommand_.setText(setting.getIndexCommand());
        }
        
        createHorizotalLine(shell);

        {
	        Composite comp = createLeftAlignmentComposite();
	        Label l = new Label(comp, SWT.NULL);
	        l.setText(Messages.getString("AdvancedIndexSettingDialog.MsOfficeIndexCommand")); //$NON-NLS-1$
        }

        {
	        Composite comp = createLeftAlignmentComposite();
	        
	        txtIndexOfficeFileCommand_ = new Text(comp, SWT.BORDER);
			txtIndexOfficeFileCommand_.setLayoutData(gridDataFillHorizontal);
	        txtIndexOfficeFileCommand_.setText(setting.getIndexOfficeFileCommand());
        }

        createHorizotalLine(shell);

        {
	        Composite comp = createLeftAlignmentComposite();
	        Label l = new Label(comp, SWT.NULL);
	        l.setText(Messages.getString("AdvancedIndexSettingDialog.PurgeCommand")); //$NON-NLS-1$
        }

        {
	        Composite comp = createLeftAlignmentComposite();
	        
	        txtPurgeCommand_ = new Text(comp, SWT.BORDER);
			txtPurgeCommand_.setLayoutData(gridDataFillHorizontal);
	        txtPurgeCommand_.setText(setting.getPurgeCommand());
        }

        createHorizotalLine(shell);

        {
	        Composite comp = createLeftAlignmentComposite();
	        Label l = new Label(comp, SWT.NULL);
	        l.setText(Messages.getString("AdvancedIndexSettingDialog.ExtractKeywordCommand")); //$NON-NLS-1$
        }

        {
	        Composite comp = createLeftAlignmentComposite();
	        
	        txtExtractKeywordsCommand_ = new Text(comp, SWT.BORDER);
			txtExtractKeywordsCommand_.setLayoutData(gridDataFillHorizontal);
	        txtExtractKeywordsCommand_.setText(setting.getExtractKeywordsCommand());
        }

        createHorizotalLine(shell);

        {
	        Composite comp = createLeftAlignmentComposite();
	        Label l = new Label(comp, SWT.NULL);
	        l.setText(Messages.getString("AdvancedIndexSettingDialog.OptimizeCommand")); //$NON-NLS-1$
        }

        {
	        Composite comp = createLeftAlignmentComposite();
	        
	        txtOptimizeCommand_ = new Text(comp, SWT.BORDER);
			txtOptimizeCommand_.setLayoutData(gridDataFillHorizontal);
	        txtOptimizeCommand_.setText(setting.getOptimizeCommand());
        }

        {
	        Composite comp = createLeftAlignmentComposite();
	        comp.setLayoutData(gridDataFillBoth);
        }
        
        {
	        Composite comp = createRightAlignmentComposite();
	        Button btnReset = new Button(comp, SWT.PUSH);
	        btnReset.setText(Messages.getString("AdvancedIndexSettingDialog.Reset")); //$NON-NLS-1$
	        btnReset.addSelectionListener(new SelectionListener() {
				public void widgetSelected(SelectionEvent arg0) {
					btnReset_widgetSelected(arg0);
				}
				public void widgetDefaultSelected(SelectionEvent arg0) {
				}
	        });
        }

        // OK, LZ{^
        Composite bottom = createRightAlignmentComposite();
        btnOk_ = new Button(bottom, SWT.PUSH);
        btnOk_.setText(Messages.getString("AdvancedIndexSettingDialog.OK")); //$NON-NLS-1$
        shell.setDefaultButton(btnOk_);
        btnCancel_ = new Button(bottom, SWT.PUSH);
        btnCancel_.setText(Messages.getString("AdvancedIndexSettingDialog.Cancel")); //$NON-NLS-1$
        btnOk_.addSelectionListener(new SelectionListener() {
			public void widgetSelected(SelectionEvent arg0) {
				btnOk_widgetSelected(arg0);
			}
			public void widgetDefaultSelected(SelectionEvent arg0) {
			}
        });
        btnCancel_.addSelectionListener(new SelectionAdapter() {
            public void widgetSelected(SelectionEvent arg0) {
                shell_.close();
            }
        });
    }
	
	/**
	 * [ݒɖ߂]{^ꂽƂɌĂ΂郁\bh
	 * 
	 * @param arg0
	 */
	protected void btnReset_widgetSelected(SelectionEvent arg0) {
		AdvancedIndexSettingModel model = new AdvancedIndexSettingModel();

		txtIndexCommand_.setText( 			model.getIndexCommand() );
		txtIndexOfficeFileCommand_.setText( model.getIndexOfficeFileCommand() );
		txtPurgeCommand_.setText( 			model.getPurgeCommand() );
		txtExtractKeywordsCommand_.setText( model.getExtractKeywordsCommand() );
		txtOptimizeCommand_.setText( 		model.getOptimizeCommand() );
	}

	/**
	 * E񂹂̃R|[lg𐶐郁\bh
	 * 
	 * @return
	 */
    private Composite createLeftAlignmentComposite() {
        Composite c = new Composite(shell_, SWT.NONE);
        GridLayout layout = new GridLayout(3, false);
        layout.horizontalSpacing = HORIZONTAL_SPACING;
        layout.marginWidth = MARGIN_WIDTH;
        layout.marginHeight = MARGIN_HEIGHT;
        c.setLayout(layout);
        GridData data = new GridData(GridData.HORIZONTAL_ALIGN_FILL);
        c.setLayoutData(data);
        return c;
    }

	/**
	 * E񂹂̃R|[lg𐶐郁\bh
	 * 
	 * @return
	 */
    private Composite createRightAlignmentComposite() {
        Composite c = new Composite(shell_, SWT.NONE);
        GridLayout layout = new GridLayout(2, false);
        layout.horizontalSpacing = HORIZONTAL_SPACING;
        layout.marginWidth = MARGIN_WIDTH;
        layout.marginHeight = MARGIN_HEIGHT;
        c.setLayout(layout);
        GridData data = new GridData(GridData.HORIZONTAL_ALIGN_END);
        c.setLayoutData(data);
        return c;
    }

	/**
	 * w肳ꂽR|[lgɐ̋Eǉ郁\bh
	 * 
	 * @param c ǉΏۂ̃R|[lg
	 * @return ǉE
	 */
	private Label createHorizotalLine(Composite c) {
        Label line = new Label(c, SWT.SEPARATOR | SWT.HORIZONTAL);
        GridData data = new GridData(GridData.HORIZONTAL_ALIGN_FILL);
        line.setLayoutData(data);
        return line;
    }

	/**
	 * [OK]{^ꂽƂɌĂ΂郁\bh
	 * 
	 * @param arg0 Cxg
	 */
    protected void btnOk_widgetSelected(SelectionEvent arg0) {
    	returnValueGeneralSettings_ = new AdvancedIndexSettingModel();

    	returnValueGeneralSettings_.setIndexCommand( 			txtIndexCommand_.getText() );
    	returnValueGeneralSettings_.setIndexOfficeFileCommand( 	txtIndexOfficeFileCommand_.getText() );
    	returnValueGeneralSettings_.setExtractKeywordsCommand( 	txtExtractKeywordsCommand_.getText() );
    	returnValueGeneralSettings_.setPurgeCommand( 			txtPurgeCommand_.getText() );
    	returnValueGeneralSettings_.setOptimizeCommand( 		txtOptimizeCommand_.getText() );
    	
    	shell_.dispose();
	}

    /**
     * _CAOJ\bh
     */
    public AdvancedIndexSettingModel open() {
        shell_.open();
        Display display = getParent().getDisplay();
        
    	while (!shell_.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
    	
    	return returnValueGeneralSettings_;
    }
}
