package desktophe.dialog;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.FontData;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.FontDialog;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Spinner;
import org.eclipse.swt.widgets.TabFolder;
import org.eclipse.swt.widgets.TabItem;
import org.eclipse.swt.widgets.Text;

import desktophe.Messages;
import desktophe.Util;
import desktophe.model.GeneralSettingsModel;

/**
 * SʓIȐݒ _CAO
 * 
 * @author kohno
 */
public class GeneralSettingDialog extends Dialog {
    public static final int HORIZONTAL_SPACING = 3;
    public static final int MARGIN_WIDTH = 0;
    public static final int MARGIN_HEIGHT = 2;

    /** _CAO{ */
    private Shell shell_;

    /** OK{^ */
    private Button btnOk_;
    
    /** LZ{^ */
    private Button btnCancel_;
    
	private Spinner spinner_;
	
	/** _CAOƂɕԂ߂́AݒeێCX^X */
	GeneralSettingsModel returnValueGeneralSettings_ = null;

	/** {̈̕`ɎgptHg */
	private FontData fontDataBody_;
	private Label labelBodyFont_;
	private Text txtEcliseLimit_;
	private Button chkClip_;
	private Button chkSetFileNumberLimit_;
	
	/** ʕ\̏ */
	private Text txtFileNumberLimitation_;

	/** MIMEt@ĆuOvɕ\eIhbv_EXg */
	private Combo cmbMimeName_;
    
	/** HTMLt@ĆuOvɕ\eIhbv_EXg */
	private Combo cmbHtmlName_;
	
	
	/**
	 * RXgN^
	 * 
	 * @param parent
	 * @param setting
	 */
	public GeneralSettingDialog(Shell parent, GeneralSettingsModel setting) {
    	super(parent, SWT.APPLICATION_MODAL);
    	
    	assert setting != null;

        shell_ = new Shell(parent, SWT.DIALOG_TRIM | SWT.RESIZE | SWT.APPLICATION_MODAL);
        
        createComponents(shell_, setting);
        shell_.setSize(350, 270);
        Util.setShellCenter(shell_);
	}

    /**
     * _CAÕR|[lg𐶐郁\bh
     * 
     * @param shell _CAOShell
     */
	private void createComponents(Shell shell, GeneralSettingsModel setting) {
    	assert setting != null;
    	
        GridData gridDataFillHorizontal = new GridData(GridData.FILL_HORIZONTAL);	// ɁATCYgݒ
    	GridData gridDataFillBoth = new GridData(GridData.FILL_BOTH);				// AƂATCYgݒ

    	GridLayout layout = new GridLayout(1, false);
        layout.marginWidth = 10;
    	
    	shell.setLayout(layout);
        shell.setLayoutData(gridDataFillHorizontal);
        shell.setText(Messages.getString("GeneralSettingDialog.Title")); //$NON-NLS-1$

    	TabFolder tabFolder = new TabFolder(shell, SWT.NULL);
    	tabFolder.setLayoutData(gridDataFillBoth);

    	TabItem tabitem1 = new TabItem(tabFolder, SWT.NULL);
    	tabitem1.setText(Messages.getString("GeneralSettingDialog.TabItem1")); //$NON-NLS-1$

    	TabItem tabitem2 = new TabItem(tabFolder, SWT.NULL);
    	tabitem2.setText(Messages.getString("GeneralSettingDialog.TabItem2")); //$NON-NLS-1$

    	TabItem tabitem3 = new TabItem(tabFolder, SWT.NULL);
    	tabitem3.setText(Messages.getString("GeneralSettingDialog.TabItem3")); //$NON-NLS-1$
        
        // ""^ũRg[𐶐
        {
	        Composite comp = createLeftAlignmentComposite(tabFolder);
	        Label l = new Label(comp, SWT.NULL);
	        l.setText(Messages.getString("GeneralSettingDialog.HistoryCount")); //$NON-NLS-1$
	        
	        spinner_ = new Spinner (comp, SWT.BORDER);
	        spinner_.setSelection(setting.getMaxHistoryCount());

	        tabitem1.setControl(comp);
        }
        
        // "t@Cꗗ"^ũRg[𐶐
        {
	        Composite basecomp = createLeftAlignmentComposite(tabFolder);
	        basecomp.setLayout(layout);
	        basecomp.setLayoutData(gridDataFillHorizontal);

	        {
    	        Composite comp = createLeftAlignmentComposite(basecomp);
    	        chkClip_ = new Button(comp, SWT.CHECK);
    			chkClip_.setText(Messages.getString("GeneralSettingDialog.GroupSimilarFiles")); //$NON-NLS-1$
    	        chkClip_.setSelection( setting.isClipFiles() );
    	        chkClip_.addSelectionListener(new SelectionListener() {
    				public void widgetSelected(SelectionEvent arg0) {
    					chkClip_widgetSelected(arg0);
    				}
    				public void widgetDefaultSelected(SelectionEvent arg0) {
    				}
    	        });
            }
        	
	        {
		        Composite comp = createLeftAlignmentComposite(basecomp);
		        
		        Label label = new Label(comp, SWT.NULL);
		        label.setText(Messages.getString("GeneralSettingDialog.GroupingThreshold")); //$NON-NLS-1$
		        txtEcliseLimit_ = new Text(comp, SWT.BORDER);
				txtEcliseLimit_.setText( new Float(setting.getEclipseLimit()).toString());
				txtEcliseLimit_.setEnabled( setting.isClipFiles() );
				
				Label label2 = new Label(comp, SWT.NULL);
				label2.setText("(0.0`1.0)");
	        }

	        createHorizotalLine(basecomp);

	        {
		        Composite comp = createLeftAlignmentComposite(basecomp);
		        chkSetFileNumberLimit_ = new Button(comp, SWT.CHECK);
				chkSetFileNumberLimit_.setText(Messages.getString("GeneralSettingDialog.SetLimitForResults1")); //$NON-NLS-1$
		        chkSetFileNumberLimit_.setSelection( setting.isLimitFileNumber() );
		        chkSetFileNumberLimit_.addSelectionListener(new SelectionListener() {
					public void widgetSelected(SelectionEvent arg0) {
						chkSetFileNumberLimit_widgetSelected(arg0);
					}
					public void widgetDefaultSelected(SelectionEvent arg0) {
					}
		        });
		        
		        txtFileNumberLimitation_ = new Text(comp, SWT.BORDER);
				txtFileNumberLimitation_.setText( Integer.toString( setting.getFileNumberLimitation() ) );
				txtFileNumberLimitation_.setEnabled( setting.isLimitFileNumber() );
		        
		        Label label = new Label(comp, SWT.NULL);
		        label.setText(Messages.getString("GeneralSettingDialog.SetLimitForResults2")); //$NON-NLS-1$

	        }

	        createHorizotalLine(basecomp);

	        {
		        Composite comp = createLeftAlignmentComposite(basecomp);
		        
		        Label label = new Label(comp, SWT.NULL);
		        label.setText(Messages.getString("GeneralSettingDialog.MimeFileName"));  //$NON-NLS-1$

		        cmbMimeName_ = new Combo(comp, SWT.READ_ONLY);
		        cmbMimeName_.add(Messages.getString("GeneralSettingDialog.MimeFileName.FileName"), GeneralSettingsModel.MIME_SHOW_FILENAME); //$NON-NLS-1$
		        cmbMimeName_.add(Messages.getString("GeneralSettingDialog.MimeFileName.Subject"), GeneralSettingsModel.MIME_SHOW_SUBJECT); //$NON-NLS-1$
		        cmbMimeName_.add(Messages.getString("GeneralSettingDialog.MimeFileName.FileNameAndSubject"), GeneralSettingsModel.MIME_SHOW_FILENAME_SUBJECT); //$NON-NLS-1$
		        cmbMimeName_.add(Messages.getString("GeneralSettingDialog.MimeFileName.SubjectAndFileName"), GeneralSettingsModel.MIME_SHOW_SUBJECT_FILENAME); //$NON-NLS-1$

		        cmbMimeName_.select( setting.getMimeNameFlag() );  
	        }

	        {
		        Composite comp = createLeftAlignmentComposite(basecomp);
		        
		        Label label = new Label(comp, SWT.NULL);
		        label.setText(Messages.getString("GeneralSettingDialog.HtmlFileName"));  //$NON-NLS-1$

		        cmbHtmlName_ = new Combo(comp, SWT.READ_ONLY);
		        cmbHtmlName_.add(Messages.getString("GeneralSettingDialog.HtmlFileName.FileName"), GeneralSettingsModel.HTML_SHOW_FILENAME); //$NON-NLS-1$
		        cmbHtmlName_.add(Messages.getString("GeneralSettingDialog.HtmlFileName.Title"), GeneralSettingsModel.HTML_SHOW_TITLE); //$NON-NLS-1$
		        cmbHtmlName_.add(Messages.getString("GeneralSettingDialog.HtmlFileName.FileNameAndTitle"), GeneralSettingsModel.HTML_SHOW_FILENAME_TITLE); //$NON-NLS-1$
		        cmbHtmlName_.add(Messages.getString("GeneralSettingDialog.HtmlFileName.TitleAndFileName"), GeneralSettingsModel.HTML_SHOW_TITLE_FILENAME); //$NON-NLS-1$

		        cmbHtmlName_.select( setting.getHtmlNameFlag());  
	        }

	        tabitem2.setControl(basecomp);
        }

        // "{\"^ũRg[𐶐
        {
	        Composite comp = createLeftAlignmentComposite(tabFolder);
	        
	        labelBodyFont_ = new Label(comp, SWT.NULL);
			labelBodyFont_.setText(Messages.getString("GeneralSettingDialog.BodyTextFont") + setting.getFontDataBody().getName() + Messages.getString("GeneralSettingDialog.BodyTextFontSize") + setting.getFontDataBody().getHeight() + "  "); //$NON-NLS-1$ //$NON-NLS-2$
			labelBodyFont_.setLayoutData(gridDataFillHorizontal);
			fontDataBody_ = setting.getFontDataBody();
	        
	        Button btnChangeFont = new Button(comp, SWT.PUSH);
	        btnChangeFont.setText(Messages.getString("GeneralSettingDialog.ButtonChangeFont")); //$NON-NLS-1$
	        btnChangeFont.addSelectionListener(new SelectionListener() {
				public void widgetSelected(SelectionEvent arg0) {
					btnChangeFont_widgetSelected(arg0);
				}
	
				public void widgetDefaultSelected(SelectionEvent arg0) {
				}
	        });

	        tabitem3.setControl(comp);
        }

        // OK, LZ{^
        Composite bottom = createRightAlignmentComposite();
        btnOk_ = new Button(bottom, SWT.PUSH);
        btnOk_.setText(Messages.getString("GeneralSettingDialog.OK")); //$NON-NLS-1$
        shell.setDefaultButton(btnOk_);
        btnCancel_ = new Button(bottom, SWT.PUSH);
        btnCancel_.setText(Messages.getString("GeneralSettingDialog.Cancel")); //$NON-NLS-1$
        btnOk_.addSelectionListener(new SelectionListener() {
			public void widgetSelected(SelectionEvent arg0) {
				btnOk_widgetSelected(arg0);
			}
			public void widgetDefaultSelected(SelectionEvent arg0) {
			}
        });
        btnCancel_.addSelectionListener(new SelectionAdapter() {
            public void widgetSelected(SelectionEvent arg0) {
                shell_.close();
            }
        });
    }
	
	/**
	 * [\ɏ݂]`FbN{bNXIꂽƂɌĂ΂郁\bh
	 * 
	 * @param arg0
	 */
	protected void chkSetFileNumberLimit_widgetSelected(SelectionEvent arg0) {
		txtFileNumberLimitation_.setEnabled( chkSetFileNumberLimit_.getSelection() );
	}

	/**
	 * [ގ܂Ƃ߂]`FbN{bNXIꂽƂɌĂ΂郁\bh
	 * 
	 */
	protected void chkClip_widgetSelected(SelectionEvent arg0) {
		txtEcliseLimit_.setEnabled( chkClip_.getSelection() );
	}

	/**
	 * {\tHg[ύX]NbNꂽƂɌĂ΂郁\bh
	 */
	protected void btnChangeFont_widgetSelected(SelectionEvent arg0) {
		FontDialog dialog = new FontDialog(shell_);
		dialog.setFontList(new FontData[]{ fontDataBody_ });
		
		FontData data = dialog.open();
		if (data == null)  return;
		
		fontDataBody_ = data;
		labelBodyFont_.setText(Messages.getString("GeneralSettingDialog.BodyTextFont") + fontDataBody_.getName() + Messages.getString("GeneralSettingDialog.BodyTextFontSize") + fontDataBody_.getHeight()); //$NON-NLS-1$ //$NON-NLS-2$
	}

	/**
	 * E񂹂̃R|[lg𐶐郁\bh
	 * 
	 * @return
	 */
    private Composite createLeftAlignmentComposite(Composite parent) {
        Composite c = new Composite(parent, SWT.NONE);
        GridLayout layout = new GridLayout(3, false);
        layout.horizontalSpacing = HORIZONTAL_SPACING;
        layout.marginWidth = MARGIN_WIDTH;
        layout.marginHeight = MARGIN_HEIGHT;
        c.setLayout(layout);
        GridData data = new GridData(GridData.HORIZONTAL_ALIGN_FILL);
        c.setLayoutData(data);
        return c;
    }

	/**
	 * E񂹂̃R|[lg𐶐郁\bh
	 * 
	 * @return
	 */
    private Composite createRightAlignmentComposite() {
        Composite c = new Composite(shell_, SWT.NONE);
        GridLayout layout = new GridLayout(2, false);
        layout.horizontalSpacing = HORIZONTAL_SPACING;
        layout.marginWidth = MARGIN_WIDTH;
        layout.marginHeight = MARGIN_HEIGHT;
        c.setLayout(layout);
        GridData data = new GridData(GridData.HORIZONTAL_ALIGN_END);
        c.setLayoutData(data);
        return c;
    }

	/**
	 * w肳ꂽR|[lgɐ̋Eǉ郁\bh
	 * 
	 * @param c ǉΏۂ̃R|[lg
	 * @return ǉE
	 */
	private Label createHorizotalLine(Composite c) {
        Label line = new Label(c, SWT.SEPARATOR | SWT.HORIZONTAL);
        GridData data = new GridData(GridData.HORIZONTAL_ALIGN_FILL);
        line.setLayoutData(data);
        return line;
    }

	/**
	 * [OK]{^ꂽƂɌĂ΂郁\bh
	 * 
	 * @param arg0 Cxg
	 */
    protected void btnOk_widgetSelected(SelectionEvent arg0) {
    	double eclipseLimit = 0.9;
    	
    	{
    		boolean valid = true;
    		String text = txtEcliseLimit_.getText();
    		
    		if (text == null || text.length() == 0)  valid = false; 

    		try {
    			eclipseLimit = Double.parseDouble(text);
    		} catch (Exception ex) {
    			valid = false;
    		}
    		
    		if (eclipseLimit < 0.0 || eclipseLimit > 1.0)  valid = false;

        	if (chkClip_.getSelection() && !valid) {
    			MessageBox box = new MessageBox(shell_, SWT.OK | SWT.ICON_WARNING);
    			box.setMessage(Messages.getString("GeneralSettingDialog.Error.GroupingThreshold")); //$NON-NLS-1$
    			box.open();
    			return;
    		}
    	}
    	
    	int fileNumberLimitation = 150;
    	
    	{
    		boolean valid = true;
    		
    		try {
    			fileNumberLimitation = Integer.parseInt( txtFileNumberLimitation_.getText() );
    		} catch (Exception ex) {
    			valid = false;
    		}
    		
    		if (fileNumberLimitation < 0)  valid = false;

        	if (chkSetFileNumberLimit_.getSelection() && !valid) {
    			MessageBox box = new MessageBox(shell_, SWT.OK | SWT.ICON_WARNING);
    			box.setMessage(Messages.getString("GeneralSettingDialog.Error.LimitForResults")); //$NON-NLS-1$
    			box.open();
    			return;
    		}
    	}
    	
    	
    	returnValueGeneralSettings_ = new GeneralSettingsModel();
    	
    	returnValueGeneralSettings_.setMaxHistoryCount( spinner_.getSelection() );
    	returnValueGeneralSettings_.setFontDataBody( fontDataBody_ );
    	returnValueGeneralSettings_.setClipFiles( chkClip_.getSelection() );
    	returnValueGeneralSettings_.setEclipseLimit((float)eclipseLimit);
    	returnValueGeneralSettings_.setLimitFileNumber( chkSetFileNumberLimit_.getSelection() );
    	returnValueGeneralSettings_.setFileNumberLimitation( fileNumberLimitation );
    	returnValueGeneralSettings_.setMimeNameFlag( cmbMimeName_.getSelectionIndex() );
    	returnValueGeneralSettings_.setHtmlNameFlag( cmbHtmlName_.getSelectionIndex() );
    	
    	shell_.dispose();
	}

    /**
     * _CAOJ\bh
     */
    public GeneralSettingsModel open() {
        shell_.open();
        Display display = getParent().getDisplay();
        
    	while (!shell_.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
    	
    	return returnValueGeneralSettings_;
    }
}
