package desktophe.dialog;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.ProgressBar;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import desktophe.Messages;
import desktophe.Util;

/**
 * i󋵂\邽߂̃_CAO
 * 
 * @author kohno
 */
public class ProgressDialog extends Dialog {
    /** _CAO{ */
    private Shell shell_;
    
	private Label labelTop_;
	
	/** sĂvZX̏o͂\eLXg{bNX */
	private Text text_;
	private ProgressBar progressbar_;
	
	/** []{^ */
	private Button btnColose_;

    
	/**
	 * RXgN^
	 * 
	 * @param arg0 eEBhE
	 */
	public ProgressDialog(Shell arg0) {
		super(arg0);
		
        shell_ = new Shell(arg0, SWT.DIALOG_TRIM | SWT.RESIZE);
        shell_.addListener(SWT.Traverse, new Listener() {
			public void handleEvent(Event arg0) {
				shell_handleEvent_Traverse(arg0);
			}
        });
        shell_.addListener(SWT.Close, new Listener() {
			public void handleEvent(Event arg0) {
				shell_handleEvent_Close(arg0);
			}
        });

        createComponents(shell_);
        shell_.setSize(500, 300);
        Util.setShellCenter(shell_);
	}
	
    /**
     * _CAOƂɌĂ΂郁\bh
     * 
     * @param arg0
     */
    protected void shell_handleEvent_Close(Event e) {
    	if (btnColose_.getEnabled()) {
    		// eEBhE𑀍\ɂ
    		getParent().setEnabled(true);
    	} else {
    		// Ȃ悤ɂ
       		e.doit = false;
    	}
	}

	/**
     * _CAOɑ΂ẴCxg郁\bh
     * 
     * @param arg0 Cxg
     */
    protected void shell_handleEvent_Traverse(Event e) {
    	if (e.detail == SWT.TRAVERSE_ESCAPE) {
    		// EscL[Ń_CAOȂ悤ɂ
			e.doit = btnColose_.getEnabled();
		}
    }

    /**
     * _CAÕR|[lg𐶐郁\bh
     * 
     * @param shell _CAOShell
     */
	private void createComponents(Shell shell) {
        GridData gridDataFillBoth = new GridData(GridData.FILL_BOTH);	// AƂATCYgݒ
        GridData gridDataFillHorizontal = new GridData(GridData.HORIZONTAL_ALIGN_FILL);
        
        GridLayout layout = new GridLayout(1, false);
        shell.setLayout(layout);
        shell.setText(Messages.getString("ProgressDialog.Title")); //$NON-NLS-1$
        
        labelTop_ = new Label(shell, SWT.NULL);
        labelTop_.setLayoutData(gridDataFillHorizontal);

        progressbar_ = new ProgressBar (shell, SWT.SMOOTH);
		progressbar_.setLayoutData(gridDataFillHorizontal);
        
        // E
        createHorizotalLine(shell);

        text_ = new Text(shell, SWT.MULTI | SWT.BORDER | SWT.H_SCROLL | SWT.V_SCROLL | SWT.WRAP);
		text_.setEditable(false);
		text_.setLayoutData(gridDataFillBoth);

        // E
        createHorizotalLine(shell);

        Composite bottom = createRightAlignmentComposite();
        btnColose_ = new Button(bottom, SWT.PUSH);
		btnColose_.setText(Messages.getString("ProgressDialog.CloseButton")); //$NON-NLS-1$
        btnColose_.setEnabled(false);
        shell.setDefaultButton(btnColose_);
        btnColose_.addSelectionListener(new SelectionListener() {
			public void widgetSelected(SelectionEvent arg0) {
				btnColose_widgetSelected(arg0);
			}
			public void widgetDefaultSelected(SelectionEvent arg0) {
			}
        });
	}

	/**
	 * []{^ꂽƂɌĂ΂郁\bh
	 * 
	 * @param arg0 ZNVCxg
	 */
	protected void btnColose_widgetSelected(SelectionEvent arg0) {
		shell_.close();
	}

	/**
	 * w肳ꂽR|[lgɐ̋Eǉ郁\bh
	 * 
	 * @param c ǉΏۂ̃R|[lg
	 * @return ǉE
	 */
	private Label createHorizotalLine(Composite c) {
        Label line = new Label(c, SWT.SEPARATOR | SWT.HORIZONTAL);
        GridData data = new GridData(GridData.HORIZONTAL_ALIGN_FILL);
        line.setLayoutData(data);
        return line;
    }

    /**
     * _CAOJ\bh
     */
    public void open() {
    	getParent().setEnabled(false);
        shell_.open();
    }
	
    /**
     * vOXo[̕\^\ݒ肷郁\bh
     * 
     * @param b vOXo[\ꍇtrueA\ɂꍇfalse
     */
    public void setProgressbarVisible(boolean b) {
    	progressbar_.setVisible(b);
    }
 
    /**
     * eLXgGAɕǉ郁\bh
     * 
     * @param newline ǉ镶
     */
    public void addText(String newline) {
    	if (newline == null)  return;
    	
    	text_.append(newline + "\n");
    }

    /**
     * x̕ݒ肷镶
     * 
     * @param str 
     */
    public void setLabelText(String str) {
    	labelTop_.setText(str);
    }

	/**
	 * E񂹂̃R|[lg𐶐郁\bh
	 * 
	 * @return
	 */
    private Composite createRightAlignmentComposite() {
        Composite c = new Composite(shell_, SWT.NONE);
        GridLayout layout = new GridLayout(1, false);
        c.setLayout(layout);
        GridData data = new GridData(GridData.HORIZONTAL_ALIGN_END);
        c.setLayoutData(data);
        return c;
    }

    /**
     * []{^̗L^ݒ肷郁\bh
     * 
     * @param b []{^LɂꍇtrueAɂꍇfalse
     */
    public void setCloseButtonEnabled(boolean b) {
    	btnColose_.setEnabled(b);
    }
    
    /**
     * vOXo[̍őlݒ肷郁\bh
     * 
     * @param v vOXo[̍ől
     */
    public void setProgressBarMaximum(int v) {
    	progressbar_.setMaximum(v);
    }

    /**
     * vOXo[̒lݒ肷郁\bh
     * 
     * @param v vOXo[̒l
     */
    public void setProgressBarSelection(int v) {
    	progressbar_.setSelection(v);
    }

    /**
     * vOXo[݂̌̒lԂ\bh
     * 
     * @return vOXo[݂̌̒l
     */
    public int getProgressBarSelection() {
    	return progressbar_.getSelection();
    }
}
