package desktophe.model;

import java.util.Properties;

import org.eclipse.swt.graphics.FontData;

import desktophe.Messages;

/**
 * SʓIȐݒ̓eێ邽߂̃NX
 * 
 * @author kohno
 */
public class GeneralSettingsModel {
	/** ێ錏 */
	private int maxHistoryCount_;
	
	/** {̈̕`ɎgptHg */
	private FontData fontDataBody_;
	
	/** ގ܂Ƃ߂ĕ\邩ǂ */
	private boolean clipFiles_;

	/** ܂Ƃ߂Ƃ̉ގx */
	private float eclipseLimit_;
	
	/** ʂ̕\݂̏邩ǂ */
	private boolean limitFileNumber_;

	/** \t@C̏ */
	private int fileNumberLimitation_;

	public static final int MIME_SHOW_FILENAME = 0;
	public static final int MIME_SHOW_SUBJECT = 1;
	public static final int MIME_SHOW_FILENAME_SUBJECT = 2;
	public static final int MIME_SHOW_SUBJECT_FILENAME = 3;
	
	public static final int HTML_SHOW_FILENAME = 0;
	public static final int HTML_SHOW_TITLE = 1;
	public static final int HTML_SHOW_FILENAME_TITLE = 2;
	public static final int HTML_SHOW_TITLE_FILENAME = 3;

	/** MIME^Cṽt@CŁAuOvɉ\邩̃tO */
	private int mimeNameFlag_;
	
	/** HTML^Cṽt@CŁAuOvɉ\邩̃tO */
	private int htmlNameFlag_;
	
	
	/**
	 * RXgN^
	 */
	public GeneralSettingsModel() {
		maxHistoryCount_ = 30;
		fontDataBody_ = new FontData(Messages.getString("GeneralSettingsModel.DefaultBodyFont"), 10, 0); //$NON-NLS-1$
		clipFiles_ = true;
		eclipseLimit_ = 0.9f;
		limitFileNumber_ = true;
		fileNumberLimitation_ = 50;
		mimeNameFlag_ = MIME_SHOW_FILENAME;
		htmlNameFlag_ = HTML_SHOW_FILENAME;
	}

	/**
	 * nꂽProperties ɐݒlL^郁\bh
	 * 
	 * @param prop ݒlL^Properties
	 */
	public void save(Properties prop) {
		prop.setProperty("GeneralSettings_maxHistoryCount", 		Integer.toString(maxHistoryCount_));
		prop.setProperty("GeneralSettings_fontDataBody_Name", 		fontDataBody_.getName());
		prop.setProperty("GeneralSettings_fontDataBody_Height", 	Integer.toString( fontDataBody_.getHeight() ));
		prop.setProperty("GeneralSettings_fontDataBody_Style", 		Integer.toString( fontDataBody_.getStyle() ));
		prop.setProperty("GeneralSettings_clipFiles", 				new Boolean(clipFiles_).toString());
		prop.setProperty("GeneralSettings_eclipseLimit", 			new Float(eclipseLimit_).toString());
		prop.setProperty("GeneralSettings_limitFileNumber", 		Boolean.toString( limitFileNumber_ ));
		prop.setProperty("GeneralSettings_fileNumberLimitation", 	Integer.toString( fileNumberLimitation_ ));
		prop.setProperty("GeneralSettings_mimeNameFlag", 			Integer.toString( mimeNameFlag_ ));
		prop.setProperty("GeneralSettings_htmlNameFlag", 			Integer.toString( htmlNameFlag_ ));
	}

	/**
	 * nꂽProperties ̃CX^XAݒlǂݏo\bh
	 * 
	 * @param prop ݒlǂݏoProperties
	 */
	public void load(Properties prop) {
		if (prop.getProperty("GeneralSettings_maxHistoryCount") != null) {
			maxHistoryCount_ = Integer.parseInt( prop.getProperty("GeneralSettings_maxHistoryCount") );
		}

		if (prop.getProperty("GeneralSettings_fontDataBody_Name") != null) {
			fontDataBody_.setName( prop.getProperty("GeneralSettings_fontDataBody_Name") );
		}
		
		if (prop.getProperty("GeneralSettings_fontDataBody_Height") != null) {
			fontDataBody_.setHeight( Integer.parseInt( prop.getProperty("GeneralSettings_fontDataBody_Height") ) );
		}
		
		if (prop.getProperty("GeneralSettings_fontDataBody_Style") != null) {
			fontDataBody_.setStyle( Integer.parseInt( prop.getProperty("GeneralSettings_fontDataBody_Style") ) );
		}

		if (prop.getProperty("GeneralSettings_clipFiles") != null) {
			clipFiles_ = new Boolean( prop.getProperty("GeneralSettings_clipFiles") ).booleanValue();
		}
		
		if (prop.getProperty("GeneralSettings_eclipseLimit") != null) {
			eclipseLimit_ = new Float( prop.getProperty("GeneralSettings_eclipseLimit") ).floatValue();
		}

		if (prop.getProperty("GeneralSettings_limitFileNumber") != null) {
			limitFileNumber_ = Boolean.valueOf( prop.getProperty("GeneralSettings_limitFileNumber") ).booleanValue();
		}
		
		if (prop.getProperty("GeneralSettings_fileNumberLimitation") != null) {
			fileNumberLimitation_ = Integer.parseInt( prop.getProperty("GeneralSettings_fileNumberLimitation") );
		}

		if (prop.getProperty("GeneralSettings_mimeNameFlag") != null) {
			mimeNameFlag_ = Integer.parseInt( prop.getProperty("GeneralSettings_mimeNameFlag") );
		}

		if (prop.getProperty("GeneralSettings_htmlNameFlag") != null) {
			htmlNameFlag_ = Integer.parseInt( prop.getProperty("GeneralSettings_htmlNameFlag") );
		}
	}

	/**
	 * @return maxHistoryCount_ ߂܂B
	 */
	public int getMaxHistoryCount() {
		return maxHistoryCount_;
	}

	/**
	 * @param maxHistoryCount ݒ肷 maxHistoryCountB
	 */
	public void setMaxHistoryCount(int maxHistoryCount) {
		this.maxHistoryCount_ = maxHistoryCount;
	}

	/**
	 * @return fontDataBody_ ߂܂B
	 */
	public FontData getFontDataBody() {
		return fontDataBody_;
	}

	/**
	 * @param fontDataBody ݒ肷 fontDataBodyB
	 */
	public void setFontDataBody(FontData fontDataBody) {
		this.fontDataBody_ = fontDataBody;
	}

	/**
	 * @return clipFiles_ ߂܂B
	 */
	public boolean isClipFiles() {
		return clipFiles_;
	}

	/**
	 * @param clipFiles_ ݒ肷 clipFiles_B
	 */
	public void setClipFiles(boolean clipFiles) {
		this.clipFiles_ = clipFiles;
	}

	/**
	 * @return eclipseLimit_ ߂܂B
	 */
	public float getEclipseLimit() {
		return eclipseLimit_;
	}

	/**
	 * @param eclipseLimit_ ݒ肷 eclipseLimit_B
	 */
	public void setEclipseLimit(float eclipseLimit) {
		this.eclipseLimit_ = eclipseLimit;
	}

	/**
	 * @return fileNumberLimitation_ ߂܂B
	 */
	public int getFileNumberLimitation() {
		return fileNumberLimitation_;
	}

	/**
	 * @param fileNumberLimitation_ ݒ肷 fileNumberLimitation_B
	 */
	public void setFileNumberLimitation(int fileNumberLimitation) {
		this.fileNumberLimitation_ = fileNumberLimitation;
	}

	/**
	 * @return limitFileNumber_ ߂܂B
	 */
	public boolean isLimitFileNumber() {
		return limitFileNumber_;
	}

	/**
	 * @param limitFileNumber_ ݒ肷 limitFileNumber_B
	 */
	public void setLimitFileNumber(boolean limitFileNumber) {
		this.limitFileNumber_ = limitFileNumber;
	}

	/**
	 * @return the mimeNameFlag_
	 */
	public int getMimeNameFlag() {
		return mimeNameFlag_;
	}

	/**
	 * @param mimeNameFlag_ the mimeNameFlag_ to set
	 */
	public void setMimeNameFlag(int mimeNameFlag) {
		this.mimeNameFlag_ = mimeNameFlag;
	}

	/**
	 * @return the htmlNameFlag_
	 */
	public int getHtmlNameFlag() {
		return htmlNameFlag_;
	}

	/**
	 * @param htmlNameFlag_ the htmlNameFlag_ to set
	 */
	public void setHtmlNameFlag(int htmlNameFlag) {
		this.htmlNameFlag_ = htmlNameFlag;
	}
}
