package desktophe.model;

import java.io.File;
import java.util.ArrayList;
import java.util.List;
import java.util.Properties;

import javax.swing.filechooser.FileSystemView;

/**
 * CfbNXݒ̏ێNX
 * 
 * @author kohno
 */
public class IndexSettingsModel {
	/** CfbNXf[^i[tH_ */
	private String indexDataFolder_ = "";
	
    /** CfbNXΏۃtH_̃Xg */
	private List targetFolderList_ = null;
	
	/** eLXgt@CƂĈgqǉw肷邩ǂ̃tO */
	private boolean addTextExtension_ = false;
	
	/** [U[ǉw肷eLXgt@CƂĈgqBJ}ŋ؂B */
	private String additionalTextExtension_ = "";

	/** HTMLt@CƂĈgqǉw肷邩ǂ̃tO */
	private boolean addHtmlExtension_ = false;
	
	/** [U[ǉw肷HTMLt@CƂĈgqBJ}ŋ؂B */
	private String additionalHtmlExtension_ = "";

	/** MIMEt@CƂĈgqǉw肷邩ǂ̃tO */
	private boolean addMimeExtension_ = false;
	
	/** [U[ǉw肷MIMEt@CƂĈgqBJ}ŋ؂B */
	private String additionalMimeExtension_ = "";

	/** Firefox̃LbVCfbNX邱ƂtO */
	private boolean indexFirefoxCache_ = false;
	
	/** Gۃ[̃f[^CfbNX邱ƂtO */
	private boolean indexHidemaruMail_ = false;

	
	/**
	 * RXgN^
	 */
	public IndexSettingsModel() {
		indexDataFolder_ = System.getProperty("user.home");
		indexDataFolder_ += File.separator + "Application Data" + File.separator + "DesktopHE" 
			+ File.separator + "index";
		
		targetFolderList_ = new ArrayList();
		
		targetFolderList_.add(FileSystemView.getFileSystemView().getHomeDirectory().toString());
		targetFolderList_.add(FileSystemView.getFileSystemView().getDefaultDirectory().toString());
		
		indexFirefoxCache_ = false;
		indexHidemaruMail_ = false;
	}
	
	/**
	 * @return indexDataFolder_ ߂܂B
	 */
	public String getIndexDataFolder() {
		return indexDataFolder_;
	}

	/**
	 * @param indexDataFolder_ ݒ肷 indexDataFolder_B
	 */
	public void setIndexDataFolder_(String indexDataFolder) {
		this.indexDataFolder_ = indexDataFolder;
	}

	/**
	 * @return targetFolderList_ ߂܂B
	 */
	public List getTargetFolderList() {
		return targetFolderList_;
	}

	/**
	 * @param targetFolderList_ ݒ肷 targetFolderList_B
	 */
	public void setTargetFolderList_(List targetFolderList) {
		this.targetFolderList_ = targetFolderList;
	}

	/**
	 * nꂽProperties ̃CX^XAݒlǂݏo\bh
	 * 
	 * @param prop ݒlǂݏoProperties
	 */
	public void load(Properties prop) {
		String str = prop.getProperty("IndexDataFolder");
		if (str != null)  indexDataFolder_ = str;
		
		targetFolderList_.clear();
		for (int i=0; ; i++) {
			str = prop.getProperty("IndexFolder" + i);
			if (str == null)  break;
			
			targetFolderList_.add(str);
		}

		addTextExtension_ 			= Boolean.valueOf( getPropertySafe(prop, "addTextExtension") ).booleanValue();
		additionalTextExtension_ 	= getPropertySafe(prop, "additionalTextExtension");
		addHtmlExtension_ 			= Boolean.valueOf( getPropertySafe(prop, "addHtmlExtension") ).booleanValue();
		additionalHtmlExtension_ 	= getPropertySafe(prop, "additionalHtmlExtension");
		addMimeExtension_ 			= Boolean.valueOf( getPropertySafe(prop, "addMimeExtension") ).booleanValue();
		additionalMimeExtension_ 	= getPropertySafe(prop, "additionalMimeExtension");

		// Firefox̃LbV
		indexFirefoxCache_ = Boolean.valueOf( getPropertySafe(prop, "indexFirefoxCache") ).booleanValue();

		// Gۃ[
		indexHidemaruMail_ = Boolean.valueOf( getPropertySafe(prop, "indexHidemaruMail") ).booleanValue();
	}

	/**
	 * 
	 * @param prop
	 * @param key
	 * @return
	 */
	private String getPropertySafe(Properties prop, String key) {
		return prop.getProperty(key) == null ? "" : prop.getProperty(key);
	}
	
	/**
	 * nꂽProperties ɐݒlL^郁\bh
	 * 
	 * @param prop ݒlL^Properties
	 */
	public void save(Properties prop) {
		prop.setProperty("IndexDataFolder", indexDataFolder_);
		
		for (int i=0; i<targetFolderList_.size(); i++) {
			prop.setProperty("IndexFolder" + i, (String)targetFolderList_.get(i));
		}
		
		prop.setProperty("addTextExtension", 		Boolean.toString( addTextExtension_ ));
		prop.setProperty("additionalTextExtension", additionalTextExtension_);
		prop.setProperty("addHtmlExtension", 		Boolean.toString( addHtmlExtension_));
		prop.setProperty("additionalHtmlExtension", additionalHtmlExtension_);
		prop.setProperty("addMimeExtension", 		Boolean.toString( addMimeExtension_));
		prop.setProperty("additionalMimeExtension", additionalMimeExtension_);
		
		// Firefox̃LbV
		prop.setProperty("indexFirefoxCache", Boolean.toString( indexFirefoxCache_ ));

		// Gۃ[
		prop.setProperty("indexHidemaruMail", Boolean.toString( indexHidemaruMail_ ));
	}

	/**
	 * @return addHtmlExtension ߂܂B
	 */
	public boolean isAddHtmlExtension() {
		return addHtmlExtension_;
	}

	/**
	 * @param addHtmlExtension ݒ肷 addHtmlExtensionB
	 */
	public void setAddHtmlExtension(boolean addHtmlExtension) {
		this.addHtmlExtension_ = addHtmlExtension;
	}

	/**
	 * @return additionalHtmlExtension ߂܂B
	 */
	public String getAdditionalHtmlExtension() {
		if (!isAddHtmlExtension())  return "";
		
		return additionalHtmlExtension_;
	}

	/**
	 * @param additionalHtmlExtension ݒ肷 additionalHtmlExtensionB
	 */
	public void setAdditionalHtmlExtension(String additionalHtmlExtension) {
		this.additionalHtmlExtension_ = additionalHtmlExtension;
	}

	/**
	 * @return additionalMimeExtension ߂܂B
	 */
	public String getAdditionalMimeExtension() {
		if (!isAddMimeExtension())  return "";
		
		return additionalMimeExtension_;
	}

	/**
	 * @param additionalMimeExtension ݒ肷 additionalMimeExtensionB
	 */
	public void setAdditionalMimeExtension(String additionalMimeExtension) {
		this.additionalMimeExtension_ = additionalMimeExtension;
	}

	/**
	 * @return additionalTextExtension ߂܂B
	 */
	public String getAdditionalTextExtension() {
		if (!isAddTextExtension())  return "";
		
		return additionalTextExtension_;
	}

	/**
	 * @param additionalTextExtension ݒ肷 additionalTextExtensionB
	 */
	public void setAdditionalTextExtension(String additionalTextExtension) {
		this.additionalTextExtension_ = additionalTextExtension;
	}

	/**
	 * @return addMimeExtension ߂܂B
	 */
	public boolean isAddMimeExtension() {
		return addMimeExtension_;
	}

	/**
	 * @param addMimeExtension ݒ肷 addMimeExtensionB
	 */
	public void setAddMimeExtension(boolean addMimeExtension) {
		this.addMimeExtension_ = addMimeExtension;
	}

	/**
	 * @return addTextExtension ߂܂B
	 */
	public boolean isAddTextExtension() {
		return addTextExtension_;
	}

	/**
	 * @param addTextExtension ݒ肷 addTextExtensionB
	 */
	public void setAddTextExtension(boolean addTextExtension) {
		this.addTextExtension_ = addTextExtension;
	}

	public boolean isIndexFirefoxCache() {
		return indexFirefoxCache_;
	}

	public void setIndexFirefoxCache(boolean indexFirefoxCache) {
		this.indexFirefoxCache_ = indexFirefoxCache;
	}

	public boolean isIndexHidemaruMail() {
		return indexHidemaruMail_;
	}

	public void setIndexHidemaruMail(boolean indexHidemaruMail) {
		this.indexHidemaruMail_ = indexHidemaruMail;
	}
}
