package desktophe.plugin;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import desktophe.Messages;

/**
 * Firefox̃LbVCfbNXvOC
 * 
 * @author kohno
 */
public class FirefoxPlugin extends AbstractPligin {

	/**
	 * RXgN^
	 *
	 */
	public FirefoxPlugin() {
		
	}

	/**
	 * nꂽStringBufferɁACfbNXR}hރ\bh
	 * 
	 * @param buffer
	 */
	public void appendIndexCommand(StringBuffer buffer) {
		File[] folders = getFirefoxCacheFolder();
		
		if (folders == null)  return;
		
		for (int i=0; i<folders.length; i++) {
			assert folders[i].isDirectory();
			
			String path = folders[i].getPath();
			
			if (path.indexOf(' ') >= 0) {
				path = "\"" + path + "\"";
			}

			buffer.append(Messages.getString("FirefoxPlugin.IndexCommand")); //$NON-NLS-1$
			buffer.append("%INDEX_DIRECTORY% ");
			buffer.append( path );
			buffer.append("\n");
			buffer.append(Messages.getString("FirefoxPlugin.IndexingCaption")); //$NON-NLS-1$
		}
	}

	/**
	 * nꂽ StringBuffer ɁAFirefox̃LbVCfbNX폜R}hރ\bh
	 * 
	 * @param indexPath
	 * @param buffer
	 */
	public void appendPurgeCommand(String indexPath, StringBuffer buffer) {
		File[] folders = getFirefoxCacheFolder();
		
		if (folders == null)  return;

		for (int i=0; i<folders.length; i++) {
			if (!folders[i].isDirectory())  continue;

			buffer.append(Messages.getString("FirefoxPlugin.PurgeCommand")); //$NON-NLS-1$
			buffer.append(indexPath);
			buffer.append(" ");

			String path = folders[i].getPath();
			
			if (path.indexOf(' ') >= 0) {
				path = "\"" + path + "\"";
			}
			
			buffer.append(path);
			buffer.append("\n");
			buffer.append(Messages.getString("FirefoxPlugin.PurgeCaption")); //$NON-NLS-1$
		}
	}
	
	/**
	 * CfbNXf[^폜邩ǂq˂郁bZ[WԂ\bh
	 * 
	 * @return
	 */
	public String getDeleteConfirmMessage() {
		return Messages.getString("FirefoxPlugin.PurgeConfirmMessage"); //$NON-NLS-1$
	}

	/**
	 * Firefox̃LbVtH_Ԃ\bh
	 * 
	 * @return
	 */
	private File[] getFirefoxCacheFolder() {
		// Firefox̃LbVtH_T
		
		String homeFolder = System.getProperty("user.home");
		File firefoxProfileFolder = new File(homeFolder 
				+ File.separator
				+ "Local Settings"
				+ File.separator
				+ "Application Data" 
				+ File.separator
				+ "Mozilla"
				+ File.separator
				+ "Firefox"
				+ File.separator
				+ "Profiles");
		
		if (!firefoxProfileFolder.isDirectory())  return null;
		
		File[] folders = firefoxProfileFolder.listFiles();
		
		if (folders == null)  return null;
		
		List list = new ArrayList();
		
		for (int i=0; i<folders.length; i++) {
			File cacheFolder = new File(folders[i], "Cache");
			if (cacheFolder.isDirectory())  list.add(cacheFolder);
		}
		
		if (list.isEmpty())  return null;
		
		File[] cacheFolders = new File[list.size()];
		for (int i=0; i<cacheFolders.length; i++) {
			cacheFolders[i] = (File) list.get(i);
		}
		
		return cacheFolders;
	}
}
