package desktophe.thread;

import java.io.IOException;
import java.util.List;

import org.eclipse.swt.widgets.Display;

import desktophe.Messages;
import desktophe.StreamPumper;
import desktophe.dialog.ProgressDialog;
import desktophe.model.IndexSettingsModel;

/**
 * CfbNXΏۂƂă[U[ǉw肵Ăgqw肩OꂽƂACfbNX폜Xbh
 * 
 * @author kohno
 */
public class RemoveAdditionalExtensionThread extends Thread {
	private ProgressDialog dlg_;
	private List extensionList_;
	private final Display display_;
	private final IndexSettingsModel indexSettings_;
	
	/**
	 * RXgN^
	 * 
	 * @param dlg i󋵕\_CAO
	 * @param folderList 폜Ώۂ̃tH_pXi[Xg
	 */
	public RemoveAdditionalExtensionThread(final Display display, ProgressDialog dlg, List extensionList, final IndexSettingsModel indexSettings) {
		dlg_ = dlg;
		extensionList_ = extensionList;
		display_ = display;
		indexSettings_ = indexSettings;
	}
	
	/**
	 * 
	 */
	public void run() {
		display_.asyncExec(new Runnable() {
			public void run() {
				dlg_.setProgressBarMaximum( extensionList_.size() );
			}
		});
		
		String indexPath = indexSettings_.getIndexDataFolder();
		if (indexPath.indexOf(' ') >= 0) {
			// CfbNXf[^i[tH_̃pXɃXy[X܂܂̂ŁANH[e[Vň͂ށB
			indexPath = "\"" + indexPath + "\"";
		}

		String command = Messages.getString("RemoveAdditionalExtensionThread.PurgeCommand"); // +  + indexPath + " "; //$NON-NLS-1$
		
		for (int i=0; i<extensionList_.size(); i++) {
			String extension = (String)extensionList_.get(i);
			final String d = extension;
			display_.asyncExec(new Runnable() {
				public void run() {
					dlg_.setLabelText(d + Messages.getString("RemoveAdditionalExtensionThread.PurgeCaption")); //$NON-NLS-1$
				}
			});
			
			try {
				if (extension.indexOf(' ') >= 0) {
					// tH_̃pXɃXy[X܂܂̂ŁANH[e[Vň͂ށB
					extension = "\"" + extension + "\"";
				}

				Process proc = Runtime.getRuntime().exec(command + extension + "\" " + indexPath);
				
				StreamPumper inputPumper = new StreamPumper(proc.getInputStream(), display_, dlg_);
				StreamPumper errorPumper = new StreamPumper(proc.getErrorStream(), display_, dlg_);

	            inputPumper.start();
	            errorPumper.start();

	            // Wait for everything to finish
	            proc.waitFor();
	            inputPumper.join();
	            errorPumper.join();
	            proc.destroy();

				display_.asyncExec(new Runnable() {
					public void run() {
						dlg_.addText("");
						dlg_.setProgressBarSelection( dlg_.getProgressBarSelection() + 1 );
					}
				});
			} catch (IOException e1) {
				e1.printStackTrace();
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}

		display_.asyncExec(new Runnable() {
			public void run() {
				dlg_.addText(Messages.getString("RemoveAdditionalExtensionThread.DoneMessage")); //$NON-NLS-1$
				dlg_.setLabelText("");
				dlg_.setCloseButtonEnabled(true);
			}
		});
	}
}
