package desktophe.thread;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;

import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.ToolBar;
import org.eclipse.swt.widgets.ToolItem;

import desktophe.Constants;

/**
 * eLXgt@Cǂݍ݁A[S]eLXgGAɕ\Xbh
 * 
 * @author kohno
 */
public class TextFileLoadThread extends Thread {
	private Display display_;
	private final File file_;
	private StyledText text_;
	private volatile boolean stop_ = false; 
	private final ToolBar toolbar_;

	/**
	 * RXgN^
	 * 
	 * @param display
	 * @param reader
	 * @param text
	 */
	public TextFileLoadThread(final Display display, File file, StyledText text, ToolBar bar) {
		display_ = display;
		file_ = file;
		text_ = text;
		toolbar_ = bar;
	}
	
	/**
	 * 
	 */
	public void run() {
		System.out.println("TextFileLoadThread started");

		display_.asyncExec(new Runnable() {
			public void run() {
				text_.setText("");
			}
		});

    	try {
			BufferedReader reader = new BufferedReader(new FileReader(file_));

			while (true) {
				String line = reader.readLine();
				if (line == null || stop_)
					break;
				
				byte[] bytes = line.getBytes();
				final String line2 = new String(bytes, "JISAutoDetect");
				
				display_.asyncExec(new Runnable() {
					public void run() {
						if (!text_.isDisposed() && text_.getData( Constants.DATA_LOADING_FILE ) != null) {
							File loadingFile = (File) text_.getData( Constants.DATA_LOADING_FILE );
							if (loadingFile.equals( file_ )) {
								text_.append(line2 + "\n");
							}
						}
					}
				});
			}
			
			reader.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}

		display_.asyncExec(new Runnable() {
			public void run() {
				ToolItem item = toolbar_.getItem(0);
				if (item.getText().equals(Constants.TOOLITEM_TEXT_STOP_LOADING)) {
					item.dispose();
					toolbar_.getItem(0).dispose();
				}
			}
		});

		if (stop_) { 
			System.out.println("ǂݍ݂~܂B");
		} else {
			System.out.println("St@Cǂݍ݂܂B");
		}
	}
	
	/**
	 * ǂݍ݂𒆎~郁\bh
	 */
	public void stopLoading() {
		System.out.println("ǂݍ݂𒆎~܂B");
		stop_ = true;
	}
}
