package desktophetest;

import java.util.ArrayList;
import java.util.List;

import junit.framework.TestCase;
import desktophe.IndexSettingManager;
import desktophe.model.IndexSettingsModel;

public class IndexSettingManagerTest extends TestCase {

	public static void main(String[] args) {
		junit.swingui.TestRunner.run(IndexSettingManagerTest.class);
	}

	/*
	 * 'desktophe.IndexSettingManager.IndexSettingManager(IndexSettings, IndexSettings)' ̂߂̃eXgE\bh
	 */
	public void testIndexSettingManager() {

	}

	/*
	 * 'desktophe.IndexSettingManager.getRemovedTargetFolderList()' ̂߂̃eXgE\bh
	 */
	public void testGetRemovedTargetFolderList() {
		{
			List oldFolderList = new ArrayList();
			IndexSettingsModel oldSetting = new IndexSettingsModel();
			oldSetting.setTargetFolderList_(oldFolderList);

			List newFolderList = new ArrayList();
			newFolderList.add("C:\\temp");
			IndexSettingsModel newSetting = new IndexSettingsModel();
			newSetting.setTargetFolderList_(newFolderList);
			
			IndexSettingManager indexSettingManager = new IndexSettingManager(oldSetting, newSetting);
			
			List removedFolderList = indexSettingManager.getRemovedTargetFolderList();

			assertNotNull( removedFolderList );
			assertEquals(0, removedFolderList.size() );
		}

		{
			List oldFolderList = new ArrayList();
			IndexSettingsModel oldSetting = new IndexSettingsModel();
			oldFolderList.add("C:\\temp");
			oldSetting.setTargetFolderList_(oldFolderList);

			List newFolderList = new ArrayList();
			IndexSettingsModel newSetting = new IndexSettingsModel();
			newSetting.setTargetFolderList_(newFolderList);
			
			IndexSettingManager indexSettingManager = new IndexSettingManager(oldSetting, newSetting);
			
			List removedFolderList = indexSettingManager.getRemovedTargetFolderList();

			assertNotNull( removedFolderList );
			assertEquals(1, removedFolderList.size() );
			assertEquals("C:\\temp", removedFolderList.get(0));
		}

		{
			List oldFolderList = new ArrayList();
			IndexSettingsModel oldSetting = new IndexSettingsModel();
			oldFolderList.add("C:\\temp");
			oldFolderList.add("C:\\hoge\\bbb");
			oldSetting.setTargetFolderList_(oldFolderList);

			List newFolderList = new ArrayList();
			IndexSettingsModel newSetting = new IndexSettingsModel();
			newSetting.setTargetFolderList_(newFolderList);
			
			IndexSettingManager indexSettingManager = new IndexSettingManager(oldSetting, newSetting);
			
			List removedFolderList = indexSettingManager.getRemovedTargetFolderList();

			assertNotNull( removedFolderList );
			assertEquals(2, removedFolderList.size() );
			assertEquals("C:\\temp", removedFolderList.get(0));
			assertEquals("C:\\hoge\\bbb", removedFolderList.get(1));
		}

		{
			List oldFolderList = new ArrayList();
			IndexSettingsModel oldSetting = new IndexSettingsModel();
			oldFolderList.add("C:\\temp");
			oldFolderList.add("C:\\hoge\\bbb");
			oldSetting.setTargetFolderList_(oldFolderList);

			List newFolderList = new ArrayList();
			IndexSettingsModel newSetting = new IndexSettingsModel();
			newFolderList.add("C:\\hoge\\bbb");
			newSetting.setTargetFolderList_(newFolderList);
			
			IndexSettingManager indexSettingManager = new IndexSettingManager(oldSetting, newSetting);
			
			List removedFolderList = indexSettingManager.getRemovedTargetFolderList();

			assertNotNull( removedFolderList );
			assertEquals(1, removedFolderList.size() );
			assertEquals("C:\\temp", removedFolderList.get(0));
		}

		{
			List oldFolderList = new ArrayList();
			IndexSettingsModel oldSetting = new IndexSettingsModel();
			oldFolderList.add("C:\\temp");
			oldFolderList.add("C:\\hoge\\bbb");
			oldSetting.setTargetFolderList_(oldFolderList);

			List newFolderList = new ArrayList();
			IndexSettingsModel newSetting = new IndexSettingsModel();
			newFolderList.add("C:\\hoge");
			newSetting.setTargetFolderList_(newFolderList);
			
			IndexSettingManager indexSettingManager = new IndexSettingManager(oldSetting, newSetting);
			
			List removedFolderList = indexSettingManager.getRemovedTargetFolderList();

			assertNotNull( removedFolderList );
			assertEquals(1, removedFolderList.size() );
			assertEquals("C:\\temp", removedFolderList.get(0));
		}

		{
			List oldFolderList = new ArrayList();
			IndexSettingsModel oldSetting = new IndexSettingsModel();
			oldFolderList.add("C:\\temp");
			oldFolderList.add("C:\\hoge\\bbb");
			oldSetting.setTargetFolderList_(oldFolderList);

			List newFolderList = new ArrayList();
			IndexSettingsModel newSetting = new IndexSettingsModel();
			newFolderList.add("C:\\hog");
			newSetting.setTargetFolderList_(newFolderList);
			
			IndexSettingManager indexSettingManager = new IndexSettingManager(oldSetting, newSetting);
			
			List removedFolderList = indexSettingManager.getRemovedTargetFolderList();

			assertNotNull( removedFolderList );
			assertEquals(2, removedFolderList.size() );
			assertEquals("C:\\temp", removedFolderList.get(0));
			assertEquals("C:\\hoge\\bbb", removedFolderList.get(1));
		}
	}

	/*
	 * 'desktophe.IndexSettingManager.getRemovedTextExtension()' ̂߂̃eXgE\bh
	 */
	public void testGetRemovedTextExtension() {
		{
			IndexSettingsModel oldSetting = new IndexSettingsModel();
			oldSetting.setAdditionalTextExtension("");

			IndexSettingsModel newSetting = new IndexSettingsModel();
			newSetting.setAdditionalTextExtension(".rb,.sql");
			
			IndexSettingManager indexSettingManager = new IndexSettingManager(oldSetting, newSetting);
			
			List removedExtensionList = indexSettingManager.getRemovedTextExtension();

			assertNotNull( removedExtensionList );
			assertEquals(0, removedExtensionList.size() );
		}

		{
			IndexSettingsModel oldSetting = new IndexSettingsModel();
			oldSetting.setAddTextExtension(true);
			oldSetting.setAdditionalTextExtension(".rb,.sql");

			IndexSettingsModel newSetting = new IndexSettingsModel();
			newSetting.setAddTextExtension(true);
			newSetting.setAdditionalTextExtension(".rb");
			
			IndexSettingManager indexSettingManager = new IndexSettingManager(oldSetting, newSetting);
			
			List removedExtensionList = indexSettingManager.getRemovedTextExtension();

			assertNotNull( removedExtensionList );
			assertEquals(1, removedExtensionList.size() );
			assertEquals(".sql", (String)removedExtensionList.get(0) );
		}

		{
			IndexSettingsModel oldSetting = new IndexSettingsModel();
			oldSetting.setAddTextExtension(true);
			oldSetting.setAdditionalTextExtension(".rb,.sql");

			IndexSettingsModel newSetting = new IndexSettingsModel();
			newSetting.setAddTextExtension(true);
			newSetting.setAdditionalTextExtension("");
			
			IndexSettingManager indexSettingManager = new IndexSettingManager(oldSetting, newSetting);
			
			List removedExtensionList = indexSettingManager.getRemovedTextExtension();

			assertNotNull( removedExtensionList );
			assertEquals(2, removedExtensionList.size() );
			assertEquals(".rb", (String)removedExtensionList.get(0) );
			assertEquals(".sql", (String)removedExtensionList.get(1) );
		}
	}

	/*
	 * 'desktophe.IndexSettingManager.getRemovedTextExtension()' ̂߂̃eXgE\bh
	 */
	public void testGetRemovedHtmlExtension() {
		{
			IndexSettingsModel oldSetting = new IndexSettingsModel();
			oldSetting.setAdditionalHtmlExtension("");

			IndexSettingsModel newSetting = new IndexSettingsModel();
			newSetting.setAdditionalHtmlExtension(".rb,.sql");
			
			IndexSettingManager indexSettingManager = new IndexSettingManager(oldSetting, newSetting);
			
			List removedExtensionList = indexSettingManager.getRemovedHtmlExtension();

			assertNotNull( removedExtensionList );
			assertEquals(0, removedExtensionList.size() );
		}

		{
			IndexSettingsModel oldSetting = new IndexSettingsModel();
			oldSetting.setAddHtmlExtension(true);
			oldSetting.setAdditionalHtmlExtension(".rb,.sql");

			IndexSettingsModel newSetting = new IndexSettingsModel();
			newSetting.setAddHtmlExtension(true);
			newSetting.setAdditionalHtmlExtension(".rb");
			
			IndexSettingManager indexSettingManager = new IndexSettingManager(oldSetting, newSetting);
			
			List removedExtensionList = indexSettingManager.getRemovedHtmlExtension();

			assertNotNull( removedExtensionList );
			assertEquals(1, removedExtensionList.size() );
			assertEquals(".sql", (String)removedExtensionList.get(0) );
		}

		{
			IndexSettingsModel oldSetting = new IndexSettingsModel();
			oldSetting.setAddHtmlExtension(true);
			oldSetting.setAdditionalHtmlExtension(".rb,.sql");

			IndexSettingsModel newSetting = new IndexSettingsModel();
			newSetting.setAddHtmlExtension(true);
			newSetting.setAdditionalHtmlExtension("");
			
			IndexSettingManager indexSettingManager = new IndexSettingManager(oldSetting, newSetting);
			
			List removedExtensionList = indexSettingManager.getRemovedHtmlExtension();

			assertNotNull( removedExtensionList );
			assertEquals(2, removedExtensionList.size() );
			assertEquals(".rb", (String)removedExtensionList.get(0) );
			assertEquals(".sql", (String)removedExtensionList.get(1) );
		}
	}
	
	/*
	 * 'desktophe.IndexSettingManager.getRemovedTextExtension()' ̂߂̃eXgE\bh
	 */
	public void testGetRemovedMimeExtension() {
		{
			IndexSettingsModel oldSetting = new IndexSettingsModel();
			oldSetting.setAdditionalMimeExtension("");

			IndexSettingsModel newSetting = new IndexSettingsModel();
			newSetting.setAdditionalMimeExtension(".rb,.sql");
			
			IndexSettingManager indexSettingManager = new IndexSettingManager(oldSetting, newSetting);
			
			List removedExtensionList = indexSettingManager.getRemovedMimeExtension();

			assertNotNull( removedExtensionList );
			assertEquals(0, removedExtensionList.size() );
		}

		{
			IndexSettingsModel oldSetting = new IndexSettingsModel();
			oldSetting.setAddMimeExtension(true);
			oldSetting.setAdditionalMimeExtension(".rb,.sql");

			IndexSettingsModel newSetting = new IndexSettingsModel();
			newSetting.setAddMimeExtension(true);
			newSetting.setAdditionalMimeExtension(".rb");
			
			IndexSettingManager indexSettingManager = new IndexSettingManager(oldSetting, newSetting);
			
			List removedExtensionList = indexSettingManager.getRemovedMimeExtension();

			assertNotNull( removedExtensionList );
			assertEquals(1, removedExtensionList.size() );
			assertEquals(".sql", (String)removedExtensionList.get(0) );
		}

		{
			IndexSettingsModel oldSetting = new IndexSettingsModel();
			oldSetting.setAddMimeExtension(true);
			oldSetting.setAdditionalMimeExtension(".rb,.sql");

			IndexSettingsModel newSetting = new IndexSettingsModel();
			newSetting.setAddMimeExtension(true);
			newSetting.setAdditionalMimeExtension("");
			
			IndexSettingManager indexSettingManager = new IndexSettingManager(oldSetting, newSetting);
			
			List removedExtensionList = indexSettingManager.getRemovedMimeExtension();

			assertNotNull( removedExtensionList );
			assertEquals(2, removedExtensionList.size() );
			assertEquals(".rb", (String)removedExtensionList.get(0) );
			assertEquals(".sql", (String)removedExtensionList.get(1) );
		}
	}
}
