/*
 * Created on 2004/05/25
 *
 */
package hidemarumail;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import estraier.Document;

/**
 * t@C͂邽߂̃NX
 */
public class FileParser {

	/**
	 * w肳ꂽt@C͂A[f[^ɕϊĕԂ\bh
	 * 
	 * @param sourceFile ǂݍރt@C
	 * @param rootDir Gۃ[̃[gf[^tH_
	 * @return ϊ̃f[^
	 */
	public static List parse(File sourceFile, String rootDir) {
		List mailDataList = new ArrayList();
		List dataList = new ArrayList();
		List offsetList = new ArrayList();
		
		// t@CA̔zɃf[^؂蕪
		try {
			BufferedReader reader = new BufferedReader(new FileReader(sourceFile));
			List oneData = null;
			String line;
			int offset = 0;
			
			while ((line = reader.readLine()) != null) {
				if (line.startsWith("!")) {
					if (oneData != null) {
						dataList.add(oneData);
					}
					
					oneData = new ArrayList();
					offsetList.add(new Integer(offset));
				}
				
				oneData.add(line);
				
				// ItZbglvZ
				byte[] bytes = line.getBytes();
				offset += bytes.length + 2;
			}
			
			if (oneData != null) {
				dataList.add(oneData);
			}
			
			reader.close();
		} catch (IOException e1) {
			e1.printStackTrace();
			try {
				throw e1;
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		
		assert dataList.size() == offsetList.size();
		
		// ؂蕪zA[f[^ɕϊ
		for (int i=0; i<dataList.size(); i++) {
			Document m = parseLines(
					sourceFile,
					(List)dataList.get(i), 
					((Integer)offsetList.get(i)).intValue(),
					rootDir);
			mailDataList.add(m);
		}
				
		return mailDataList;
	}

	/**
	 * ̔z󂯎A[f[^𐶐ĕԂ\bh 
	 * @param data ̔z
	 * @param dir ǂݏoƃt@C̃fBNg
	 * @param sourceFile ǂݏoƃt@C
	 * @param offset ItZbgl
	 * @return [f[^
	 */
	static private Document parseLines(File sourceFile, List lineList, int offset, String rootDir) {
		Document heDocument = new Document();

	    heDocument.add_attr("@type", "message/rfc822");
	    heDocument.add_attr("@uri", DataImporter.URI_PREFIX + "://" + sourceFile.toURI() + ":" + Integer.toString( offset ));
	    heDocument.add_attr("_lpath", DataImporter.URI_PREFIX + "://" + sourceFile.toURI() + ":" + Integer.toString( offset ));
	    heDocument.add_attr(DataImporter.ATTR_SOURCE_FILE_URI, sourceFile.toURI().toString());
	    heDocument.add_attr(DataImporter.ATTR_SOURCE_FILE_NATIVE, sourceFile.getPath());

	    // Gۃ[̃tH_𑮐Ƃēo^Ă
	    {
		    assert (sourceFile.getPath().startsWith(rootDir));
		    
		    String folder = sourceFile.getPath().substring( rootDir.length() );
		    folder = folder.substring(0, folder.lastIndexOf( File.separatorChar ));
		    heDocument.add_attr("folder", folder);
	    }

		/** bZ[WID */
//		String messageid = "";
		
		/** From: */
//		String adrfromname = "";
		
		/** To: */
//		List adrtoList = new ArrayList();
//		List adrtoNameList = new ArrayList();
		
		/** CC: */
//		List adrccList = new ArrayList();
//		List adrccNameList = new ArrayList();
		
		/** BCC: */
//		List adrbccList = new ArrayList();
//		List adrbccNameList = new ArrayList();
		
		/** Subject: */
//		String subject = "";
		
//		String inreplyto = "";
//		String reference = "";
		
		List headerData = new ArrayList();

		// ܂A{擾
		{
			boolean inbody = false;
			int size = 0;
			StringBuffer bodybuffer = new StringBuffer();
			
			for (int i=0; i<lineList.size(); i++) {
				String line = (String)lineList.get(i);
				
				size += line.length() + 2;
				
				if (line.equals("") && !inbody) {
					inbody = true;
					continue;
				}
				
				if (inbody) {
					if (line.length() == 0)  	bodybuffer.append("\r\n");
					else 						bodybuffer.append(line);

					// TODO s͍폜悤ɂis܂łPł悤j
				}
				else {
					headerData.add(line);
				}
			}

			heDocument.add_text(bodybuffer.toString());
			heDocument.add_attr("@size", Integer.toString(size));
		}
		
		// wb_̏
		for (int i=0; i<headerData.size(); i++) {
			String line = (String)headerData.get(i);
			
			if (line.startsWith("Message-ID")) {
				String messageid = line.substring("Message-ID:".length()).trim();
				heDocument.add_attr("message-id", messageid);
			
			} else if (line.startsWith("References:")) {
				String reference = line.substring("References:".length()).trim();
				heDocument.add_attr("references", reference);
			
			} else if (line.startsWith("In-Reply-To:")) {
				String inreplyto = line.substring("In-Reply-To:".length()).trim();
				heDocument.add_attr("in-reply-to", inreplyto);
			
			} else if (line.startsWith("From:")) {
				heDocument.add_attr("@author", line.substring( "From:".length() ).trim());
				heDocument.add_attr("from", line.substring( "From:".length() ).trim());
				
			} else if (line.startsWith("To:")) {
				String str = line.substring("To:".length()).trim();
				
				for (int j=1; ; j++) {
					if (!((String)headerData.get(i + j)).startsWith(" ") && !((String)headerData.get(i + j)).startsWith("\t"))  break;
					
					str += "," + ((String)headerData.get(i + j)).trim();
				}

				heDocument.add_attr("to", str);
			
			} else if (line.startsWith("Cc:")) {
				String str = line.substring("Cc:".length()).trim();
				
				for (int j=1; ; j++) {
					if (!((String)headerData.get(i + j)).startsWith(" ") && !((String)headerData.get(i + j)).startsWith("\t"))  break;
					
					str += "," + ((String)headerData.get(i + j)).trim();
				}

				heDocument.add_attr("cc", str);

			} else if (line.startsWith("Bcc:")) {
				String str = line.substring("Bcc:".length()).trim();
				
				for (int j=1; ; j++) {
					if (!((String)headerData.get(i + j)).startsWith(" ") && !((String)headerData.get(i + j)).startsWith("\t"))  break;
					
					str += "," + ((String)headerData.get(i + j)).trim();
				}

				heDocument.add_attr("bcc", str);

			} else if (line.startsWith("Date:")) {
				String str = line.substring("Date:".length()).trim();
				
				heDocument.add_attr("@cdate", str);
			    heDocument.add_attr("@mdate", str);

			} else if (line.startsWith("X-Attach:")) {
			
			} else if (line.startsWith("Subject:")) {
				String subject = line.substring("Subject:".length()).trim();
			    heDocument.add_attr("@title", subject);
				heDocument.add_hidden_text(subject);
			
			} else if (line.startsWith("Priority:")) {
			
			} else if (line.startsWith("X-Priority: 1")) {
			 
			} else if (line.startsWith("X-ML-Name:")) {
				
			} else if (line.startsWith("!")) {
			}
		}
		
		return heDocument;
	}
	
	/**
	 * 
	 * @param line
	 * @param adrList
	 * @param adrNameList
	 */
/*	private static void parseAddress(String line, List adrList, List adrNameList) {
		System.out.println(line + "\n");
		
		String[] str = line.split(",");
		
		String regexString = "(.+)<([a-zA-Z0-9\\.-]+@[a-zA-Z0-9\\.-]+)>";
		Pattern pattern = Pattern.compile(regexString);

		for (int i=0; i<str.length; i++) {
			Matcher matcher = pattern.matcher(str[i]);
		
			if (matcher.find()) {
				String name = matcher.group(1).trim();
				if (name.length() > 0 && name.charAt(0) == '\"' && name.charAt(name.length() - 1) == '\"') {
					name = name.substring(1, name.length() - 1);
				}
				if (name.length() > 0 && name.charAt(0) == '\'' && name.charAt(name.length() - 1) == '\'') {
					name = name.substring(1, name.length() - 1);
				}
				adrList.add(matcher.group(2).trim());
				adrNameList.add(name);
			}
		}
	}
*/
}

